#!/usr/bin/perl -T


# Datum:	$Date: 2002/01/26 20:57:05 $
# Version: 	$Revision: 1.4 $
# License:	free for non-commercial opensource-projects 

# Author:	Dragonstorm
# Website:	www.dragon-codex.de
# Quakenet:	#dragon-codex


use strict;
use Fcntl qw/:flock/;
use CGI;
use CGI::Carp qw( fatalsToBrowser );


############################
### Variablendeklaration ###
############################


my (%param,%var,%right,@right,%home,%log_detail,%error,%file,%col,@col,@line);

my (@e,@f,$x,$y,$cur,$valid,$var_name);

my (@elements,$laenge);

my $cgi = new CGI;

my (%standard,%comment,%match,%find,%spam,$file,$tags,$position);

############################
### Variablenzuweisungen ###
############################


# Standardwerte

$file{read} = 0;
$var{query_string} = unmask($ENV{QUERY_STRING});

# Scriptname

if (defined ($ENV{SCRIPT_NAME}))  {
 $var{script} = $ENV{SCRIPT_NAME};
 while ($var{script} =~ /\//) {
  $var{script} = $';
 }
 $var{script} =~ /\./; $var{script} = $`;
} else {
 $var{script} = 'master';
}

# Datum

my @date = localtime(time()); 
$date [4]++; 
if ($date[1] < 10) { 
 $date[1] = '0' . $date[1]; 
}
$var{date} = $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900) 
                       . ' - ' . $date[2] . ':' . $date[1]; 


#######################
### Variablen laden ###
#######################


load_var('config.txt');


##############################
### Parameter ueberpruefen ###
##############################


# verschiedene Variablensets

if ( (defined ($cgi->param("home")) && $cgi->param("home") =~ /(\w+)/) || $ENV{QUERY_STRING} =~ /home\=(\w+)/){
 $cur = $1 . '.txt';	my $old_dir = $var{directory};
 load_var($cur);
 if ($var{directory} ne '') {
  foreach $var_name ( sort keys %var ) {
   $var{$var_name} =~ s/$old_dir/$var{directory}/g;
  }
 }
}

# Rechte initialisieren

get_rights();


########################################
### Aufruf in die Logdatei schreiben ###
########################################


if ($var{log} == 1) {
 $x = $var{log_detail};	$cur = ''; @e = ();
 if (defined ($log_detail{$x})) {
  @e = split(/,/, $log_detail{$x});
  $y = 0;
  while ($y < @e) {
   if ($y != 0) {
    $cur = $cur . ' [' . $var{ $e[$y] . ']' };
   }
   $y++;
  }  
 } else {
  $cur = '[' . $var{user} . ']	[' . $var{script} . '] 	[' . $var{date} . '] 	[' . $ENV{QUERY_STRING} . ']';
 }
 file_open($var{log_file},'append');
 print FILE "$cur\n";
 file_close();
}


#########################
# Dateinamen berprfen #
#########################


if (defined($cgi->param("file")) ) {
 $file = $cgi->param("file");
} else {
 error ('no_file');
}

unless (-e $file && -d $file == 0) {
 error('file_exist',$file);
}

$x = 0;	$valid = 0;		my @directory = split(/,/, $var{file_directory}); 

while ($x < @directory) {
 if ($file =~ /$directory[$x]/ && $` eq '') {
  $file = $directory[$x] . $';
  $valid = 1;
 }
 $x++;
}

unless ($valid) {
 error('no_directory',$file);  
} 


#################
### Hauptteil ###
#################


# Ueberpruefen ob der Eintrag geaendert werden darf

$var_name = $var{user_rights};

get_rights( $cgi->param($var{old_autor}) );

if ( defined ($cgi->param($var{old_autor})) == 1 && $var{user} ne $cgi->param($var{old_autor}) ) {

 if ($var_name < $right{admin}) {
  error('no_admin');
 }
 $x = $var{user_rights};
 if ($var{user_rights} >= $var_name) {
  error('no_modify',$cgi->param($var{old_autor}),$right[$x],$var{user},$right[$var_name]);
 }
}

$var{user_rights} = $var_name;

# Autornamen setzen

if ($var{user_rights} <= $right{visitor}) {
 $tags = 0;
 check_for_spam();
 if ($cgi->param($var{alias}) eq $var{no_alias}) {
  error ('no_alias');
 }
 if ($cgi->param($var{alias}) !~ /\w+/) {
  error ('invalid_alias',$cgi->param($var{alias}));
 }
} else {
 $tags = 1;
}

$cgi->param( autor => $cgi->param($var{old_autor}) );

# Datum setzen

unless ( defined( $cgi->param($var{datum})) ) {
 unless ( defined( $cgi->param($var{old_datum})) ) {
  $cgi->param( $var{datum} => $var{date} );
 } else {
  $cgi->param( $var{datum} => $cgi->param($var{old_datum}) );
 }
}


# Datei laden

file_open($file);	file_read();	file_close();	

# Rechte fuer die Datei ueberpruefen

unless(check_rights()) {
 $x = $var{user_rights};
 $y = $right[$x];
 error('right_file',$y,$file);
}

# Pruefen ob ein Userpasswort gendert werden soll

if ($file eq $var{password_file}) {

 # Ueberpruefen ob bereits ein User mit gleichem Namen existiert

 my ($pass1,$pass2) = split (/,/, $var{pass});

 my $user = $var{user};
 my $data = $cgi->param ($var{data});	$data =~ s/[^\w]//g; 	$cgi->param ($var{data} => $data);
 my $pass = $cgi->param ($pass1); 	$pass =~ s/[^\w]//g; 	$cgi->param ($pass1 => $pass);

 if (defined($data) == 0 || defined($pass) == 0 || $data eq "" || $pass eq "") {
  error ('no_account');
 } else {
  unless ($cgi->param ($pass2) eq $pass) {
   error ('no_pass_matched');
  }
  open(VERIFY, "< $var{password_file}") or error ('right_verify');; 
  my %account = split(/\|/, <VERIFY>);  close(VERIFY);
  
  unless (defined($account{$user})) {
   error('no_user_exist',$user);
  }
 }

 $file = $var{right_file};

 file_open($file);	file_read();	file_close();	

 # Rechte fuer die Datei ueberpruefen

 unless(check_rights()) {
  $x = $var{user_rights};
  $y = $right[$x];
  error('right_file',$y,$file);
 }

 # Useraccount aendern

 my ($lesen,%account);
 open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
 $lesen = <VERIFY>; close(VERIFY);
 open(CHANGE, "> $var{password_file}") or error ('right_verify');
 flock (CHANGE, LOCK_EX);
 %account = split(/\|/,$lesen); 
 $lesen =~ s/$user\|$account{$user}/$data\|$pass/;
 print CHANGE $lesen;
 close CHANGE;

 # Mail mit neuen Accountdaten senden

 if ($var{mailing} == 1) {
  send_mail_change($data,$pass);
 }
}


# Auf gleiche Eintrge pruefen

$x = search('find');

if ($x == 0) {
 error('no_entry');
} elsif ($x > 1) {
 error('more_entries',$laenge);
}

if (search('leave') > 0) {
 error('match_entry',$laenge);
}



# related links ermoeglichen

if (defined ($cgi->param("numbers")) && $cgi->param("numbers") =~ /\d/) {

 # direkt angegebene related links speichern
 @e = split (/,/, $cgi->param("numbers"));

 for ($x = 0; $x < @e; $x++) {
  if (defined ($cgi->param("desc" . $e[$x])) && defined ($cgi->param("web" . $e[$x]))) {
   $var_name = $cgi->param("desc" . $e[$x]);
   $cur = $cgi->param("web" . $e[$x]);
   
   # links korrekt ergaenzen
 
   if (defined($cgi->param("correct_links")) && $cgi->param("correct_links") eq 'true') {

    if ($cur =~ /\w+/ && $` eq '' && $' eq '') {
     $cur = 'http://www.' . $cur . '.de';
    } elsif ($cur =~ /www\./  && $` eq '') {
     $cur = 'http://' . $cur;
    } elsif ($cur !~ /\w+\.pl/ || $` ne '') {
     $cur = 'http://www.' . $cur;
    } 
   }
   $cur = '<a href=' . $cur . ' target=_blank>' . $var_name . '</a>,';
   if ($cgi->param("related_links") !~ $cur) {
    $cgi->param(related_links => $cgi->param("related_links") . $cur);
   }
  }
 }
}

if (defined($cgi->param("make_links")) && $cgi->param("make_links") eq 'true') {

 # links im Text korrekt ergaenzen

 @e = split(/,/, $var{links});
 for ($x = 0; $x < @e; $x++) {
  if (defined ($cgi->param($e[$x]))) {
   $cur = $cgi->param($e[$x]);
   $cur =~ s/(\s|\A)([\w|-]+\.\w{2,3})(\s|\Z)/$1\<a href\=http:\/\/www\.$2 target\=_blank\>$2\<\/a\>$3/g;
   $cur =~ s/(\s|\A)(www\.[\w|-]+\.\w{2,3})(\s|\Z)/$1\<a href\=http:\/\/$2 target\=_blank\>$2\<\/a\>$3/g;
   $cur =~ s/(\s|\A)(http:\/\/www\.[\w|-]\.\w{2,3})(\s|\Z)/$1\<a href\=$2 target\=_blank\>$2\<\/a\>$3/g; 
   $cgi->param($e[$x] => $cur);
  }
 }
}

if (defined($cgi->param("substitute_links")) && $cgi->param("substitute_links") eq 'true') {

 # related links im Text ersetzen

 my @temp = split (/,/, $cgi->param("related_links"));

 for ($y = 0; $y < @temp; $y++) {

  $temp[$y] =~ /\<a.*?href\s?\=\s?"?(\S+)"?.*?\>(.*?)\<\/a\>/;	$var_name = $2;

  @e = split(/,/, $var{links});

  for ($x = 0; $x < @e; $x++) {
   $cur = $cgi->param($e[$x]);
   $cur =~ s/(\s|\A)$var_name/$1$temp[$y]/g;
   $cgi->param($e[$x] => $cur);
  }
 }
}

if (defined($cgi->param("add_links")) && $cgi->param("add_links") eq 'true') {
 
 # links aus dem Text in related links aufnehmen

 @e = split(/,/, $var{links});

 for ($x = 0; $x < @e; $x++) {
  if (defined($cgi->param($e[$x]))) {
   $cur = $cgi->param($e[$x]);
   while ($cur =~ /\<a href\s?=\s?(\S+?)>(.*?)\<\/a\>/) { 
    $cur = $';
    if ($cgi->param("related_links") =~ '<a href=' . $1 . ' target=_blank>' . $2 . '</a>,') {
     $cgi->param(related_links => $cgi->param("related_links") . '<a href=' . $1 . ' target=_blank>' . $2 . '</a>,');   
    }
   }
   $cur = $cgi->param($e[$x]);
   while ($cur =~ /\<a href\s?=\s?(\S+?)\s([\w|\=|\s|\"|\.|\/]+?)>(.*?)\<\/a\>/) { 
    $cur = $';
    $y = '<a href=' . $1 . ' target=_blank>' . $3 . '</a>,';
    if ($cgi->param("related_links") !~ $y) {
     $cgi->param(related_links => $cgi->param("related_links") . $y);       
    }
   }
  }
 }
}

$cur = $cgi->param("related_links");
$cur =~ s/\<a href\= target\=_blank\>\<\/a\>\,//ig;
$cgi->param(related_links => $cur);

# Eintrag aendern

if (defined ($cgi->param($var{delete})) &&  $cgi->param($var{delete}) == 1) {

 # Eintrag lschen

 splice(@line,$position,1);

 if ($file eq $var{right_file}) {

  # Mail an geloeschtes Member verschicken 

  if ($var{mailing} == 1) {
   send_mail_delete();
  }

  # Account loeschen

  my ($lesen,%account);

  open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
  $lesen = <VERIFY>; close(VERIFY);
  open(CHANGE, "> $var{password_file}") or error ('right_verify');
  flock (CHANGE, LOCK_EX);
  %account = split(/\|/,$lesen); 
  my $userx = $cgi->param($var{old_autor});
  if (defined($account{$userx})) {
   if ($lesen =~ /\|$userx\|$account{$userx}/) {
    $lesen =~ s/\|$userx\|$account{$userx}//g;
   } elsif ($lesen =~ /$userx\|$account{$userx}\|/) {
    $lesen =~ s/$userx\|$account{$userx}\|//g;
   } else {
    $lesen =~ s/$userx\|$account{$userx}//g;
   }
  }
  print CHANGE $lesen;
  close CHANGE;

 }

 # vorhandene Kommentare auch lschen

 foreach $var_name (sort %comment) {
  if ($file =~ /$var_name/) {
   my ($file_directory,$file_first_line,$file_param) = split(/,/, $comment{$var_name});
 
   $cur = $col{$file_param};	$y = $elements[0] [$cur];
   $y = $var{comment_directory} . $y . '.txt';
    
   $y =~ /$var{comment_directory}/;	$y = $& . $';

   $x = unlink $y;
   
   if ($x != 1) {
    error('comment_delete',$y);
   }
  }
 }

} else {

 if ($file eq $var{right_file}) {

  # Kontrollieren ob die Rechte vergeben werden koennen

  if ($right { $cgi->param($var{right}) } >= $var{user_rights}) { 
   unless ($var{user} eq $cgi->param( $var{old_autor} ) && $right { $cgi->param($var{right}) } == $var{user_rights}) {
    $cur = $var{user_rights};
    error('no_right', $cgi->param($var{right}), $right[$cur]);
   }
  }
 }

 
 # Eintrag aendern

 $cur = '';	my @elem = split(/\|/, $file{first});	$x = 0;
  
 while ($x < @elem) {  

  $elem[$x] =~ s/[\s|\r|\n]//g;

  if ($x != 0) { 
   $cur = $cur . "\|";
  }

  if ( defined( $cgi->param($elem[$x])) ) {
   if ( defined( $cgi->param($elem[$x] . $var{param_add}) ) ) {
    $cur = $cur . get_input( $cgi->param($elem[$x]) . ',' . $cgi->param($elem[$x] . $var{param_add}) );
   } else {
    $cur = $cur . get_input($cgi->param($elem[$x]));
   }
  } else {
   $cur = $cur . $elements[0] [$x];
  }
  $x++;
 }

 $line[$position] = "$cur\n";
 $line[$position] =~ s/\n{2,}/\n/g;

}

# geaenderten Eintrag in die Datei schreiben

file_open($file,'write');	flock (FILE, LOCK_EX);
print FILE "$file{first}\n";	$x = 0;
while ($x < @line) {
 print FILE $line[$x];
 $x++;
}
file_close();

quit ("Change-command successfull!");


###################
### Subroutinen ###
###################


# Mail verschicken

sub send_mail_delete() {
 my ($data,$pass) = @_;

 my $mail = email_adresse_ueberpruefen( $cgi->param($var{mail}) );
   
 unless ( $mail ) {
  error ('invalid_mail', $cgi->param($var{mail}));
 } else {
  my $nick;
  if (defined($cgi->param($var{nick}))) {
   $nick = $cgi->param($var{nick});
  } else {
   $nick = $var{user};
  }

  $ENV{PATH} = $var{path};

  open MAIL, "| $var{mail_path} -t -i" or error('mail_open');

print MAIL <<ENDE_DER_NACHRICHT;
To: $mail
From: $var{mail_from}
Reply-To: $var{mail_reply}
Subject: $var{mail_subject_delete}

$var{mail_greeting} $nick,
deine Account wurde gelscht!

$var{mail_cu}

ENDE_DER_NACHRICHT

  close (MAIL) or error('mail_close');
 }
}


sub send_mail_change() {
 my ($data,$pass) = @_;

 my $mail = email_adresse_ueberpruefen( $cgi->param($var{mail}) );
   
 unless ( $mail ) {
  error ('invalid_mail', $cgi->param($var{mail}));
 } else {
  my $nick;
  if (defined($cgi->param($var{nick}))) {
   $nick = $cgi->param($var{nick});
  } else {
   $nick = $var{user};
  }

  $ENV{PATH} = $var{path};

  open MAIL, "| $var{mail_path} -t -i" or error('mail_open');

print MAIL <<ENDE_DER_NACHRICHT;
To: $mail
From: $var{mail_from}
Reply-To: $var{mail_reply}
Subject: $var{mail_subject_change}

$var{mail_greeting} $nick,
deine Accountdaten haben sich gendert:

Username: $data
Password: $pass

Hier kannst du dich einloggen: $var{mail_login}

$var{mail_cu}




PS: $var{mail_info}

ENDE_DER_NACHRICHT

  close (MAIL) or error('mail_close');
 }
}

# Daten den Suchkriterien entsprechend filtern

sub search () {
 my $old = shift;
 my $compare = 1;
 my (%search,@search,$to_be_equal,$matched);

 $to_be_equal = -1;	$valid = 0;

 foreach $var_name (sort %find) {
  if ($file =~ /$var_name/i && $valid == 0) {
   $to_be_equal = $match{$var_name};	$valid = 1;
   $x = 0; @e = split(/,/, $find{$var_name});
   while ($x < @e) {
    $y = $col{ $e[$x] };	$cur = $e[$x];
    if (defined($old) == 1) {
     $search[$y] = get_input ( $cgi->param($var{old} . $cur) );
    } else {
     $search[$y] = get_input ( $cgi->param($cur) );
    }
    $x++;
   }
  }
 }

 if ($to_be_equal == -1) {
  $var_name = 'default';
  $to_be_equal = $match{$var_name};
  $x = 0; @e = split(/,/, $find{$var_name});
  while ($x < @e) {
   $y = $col{ $e[$x] };	$cur = $e[$x];
   if (defined($old) == 1 && $old eq 'find') {
    $search[$y] = get_input ( $cgi->param($var{old} . $cur) );
   } else {
    $search[$y] = get_input ( $cgi->param($cur) );
   }
   $x++;
  }
 }

 $x = 0;	$laenge = 0;

 while($x < @line) {

  @e = ();		@e = split(/\|/,$line[$x]);

  if ($compare) {
   $y = 0;	$matched = 0;
   while ($y < @e) {
    if (defined($search[$y]) == 1 && $e[$y] eq $search[$y]) {
     $matched++;
    }	
    $y++; 
   }
   @e = split(/\|/,$line[$x]);
   if ($matched >= $to_be_equal) {
    if (defined($old) == 1 && $old eq 'find') {
     $position = $x;
    }
    unless (defined($old) == 1 && $old eq 'leave' && $x == $position) { 
     $y = 0;
     while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
     $laenge++;
    }
   }
  } else {
   $y = 0;
   while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
   $laenge++;
  }
  $x++;
 } 
 
 if ($to_be_equal > 0) {
  return $laenge;
 } else {
  return 100;
 }
}


# Text auf Spammkriterien ueberpruefen

sub check_for_spam () {
 my $temp;

 # Wiederholung

 @e = split(/,/, $spam{repetition}); 

 $x = 0;

 while ($x < @e) {
  $var_name = $e[$x];

  if (defined ($cgi->param($var_name)) ) {
   $y = $cgi->param($var_name);	$y = mask($y);
 
   $cur = $spam{letter_count} - 1;

   # -> eines Buchstaben

   while ($y =~ /\S/i) {
    $y = $';
    $temp = $&;	$temp = mask($temp);
    if ($' =~ /($temp){$cur,}/ && $` eq '') {
     error ('letter_repetition',$temp,$cur + 1)
    }
   }
 
   $cur = $spam{word_count} - 1;	$y = $cgi->param($var_name);	$y = mask($y);

   # eines Wortes

   while ($y =~ /\S{2,}/i) {
    $y = $';
    $temp = $&;	$temp = mask($temp);	
    if ($y =~ /($temp(.*)){$cur,}/) {
     if (length($& . $temp) < $spam{word_scope} * length($temp)) {
      error ('word_repetition',$temp,$cur + 1);
     }
    }
   }
  }
 
  $x++;
 }


 # Wortanzahl 

 @e = split(/,/, $spam{length}); 

 $x = 0;

 while ($x < @e) {
  if (defined ($cgi->param($e[$x])) ) {
   my @teile = split (/\s/, $cgi->param($e[$x]));   $cur = @teile;
   if ($cur < $spam{min_words}) {
    error ('words_too_less',$cur,$e[$x]);
   } elsif ($cur > $spam{max_words}) {
    error ('words_too_much',$cur,$e[$x]); 
   }
  }
  $x++;
 }

 # Namen von registrierten Usern nicht erlauben

 if ($spam{reserve_nicks} == 1) {

  my ($lesen2,@account2,$counter2,@account3,$counter3);
  open(VERIFY, $var{password_file}) or error ('right_verify'); 
  @e = split(/\|/,<VERIFY>); close(VERIFY);

  $x = 0; $y = 0; @f = ();

  while ($x < @e) {
   if ($x % 2 == 0) {
    $f [$y] = $e [$x];
    $y++;
   }
   $x++;
  } 

  $x = 0; $var_name = $cgi->param($var{alias}); $var_name =~ s/\s//g;

  while ($x < @f) {
   $f[$x] = mask($f[$x]);	$var_name = mask($var_name);
   if ($var_name =~ /$f[$x]/i || $f[$x] =~ /$var_name/i) {
    error ('user_alias',$f[$x]);
   }
   $x++;
  }
 }
 
}


################
### Wichtige ###
################


# Sonderzeichen ersetzen

sub get_input () {
 my $thing = shift;
 my ($h,$sub,$pruef);
 while ($thing =~ m/%(\w{2})/) {
  $h = $1;
  $sub = chr(hex($h)); $thing = $` . $sub . $';
 }  
 $thing =~ s/%OA/<br>/g; $thing =~ s/\+/ /g; 
 $thing =~ s/\n/<br>/g;
 $thing =~ s/\n//g; $thing =~ s/\r//g;
 $thing =~ s/\?/\&\#063\;/g;  $thing =~ s/\{/\&\#123\;/g;  
 $thing =~ s/\^/\&\#94\;/g;   
 $thing =~ s/\|/\&\#124\;/g;    
 $thing =~ s/\[/\&\#091\;/g;  $thing =~ s/\$/\&\#36\;/g;  
 #$thing =~ s/\(/\&\#40\;/g;  $thing =~ s/\)/\&\#41\;/g;  
 #$thing =~ s/\#/\&\#43\;/g;  $thing =~ s/\//\&\#47\;/g;
 #$thing =~ s/\./\&\#46\;/g;
 unless ($tags) {
  $pruef = $thing; 
  $thing =~ s/</&lt;/g;
  $thing =~ s/&lt;br>/<br>/g;
  if ($thing ne $pruef) {
   error ('tags');
  }
 }
 return $thing;
}



# Gewuenschte Ausgabe

sub quit () {

 my $text = shift;
 my $redirection;
  
 if (defined($cgi->param("home")) && $cgi->param("home") =~ /\w+/) {
  $cur = $cgi->param("home");
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text+home=$cur");
 } else {
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text");
 }

 print $redirection;  
 exit;

}

# Dateirechte mit den Userrechten vergleichen

sub check_rights () {
 my %rights;
 my $script = $var{script} . '.pl';
 if ($file{first} =~ /\|/) {
  %rights = split(/,/, $col[-1]);
 } elsif ($file{first} =~ /\<\!\-\-(.*)\-\-\>/ && $file{first} =~ /,/) {
  $file{first} =~ /\<\!\-\-(.*)\-\-\>/;
  %rights = split(/,/, $1);
 } elsif ($file{first} =~ /,/) {
  %rights = split(/,/, $file{first});
 } else {
  $rights{$script} = $var{default_rights};
 }
 $rights{$script} =~ s/\s//g;
 $x = $rights{$script};
 $rights{$script} = $right{$x};
 if ($rights{$script} !~ /\d+/) {
  $rights{$script} = $var{default_rights};
 } 
 return compare_rights ($rights{$script});
}

sub compare_rights () {
 my $file_rights = shift;
 my @conditions = split(/,/, $file_rights);
 $x = 0;
 while ($x < @conditions) {
  if ($conditions[$x] =~ /\>\=\s*(\d+)/) {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\>\s*(\d+)/) {
   if ($var{user_rights} > $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\=\s*(\d+)/) {
   if ($var{user_rights} <= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\s*(\d+)/) {
   if ($var{user_rights} < $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\=\s*(\d+)/) {
   if ($var{user_rights} = $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /(\d+)/)  {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  }
  $x++;
 }
 return 0; 
}

# Ueberpruefung der Rechte mit Hilfe des gesetzen Cookies

sub get_rights () {

 $var{user_rights} = $right{visitor};
 my $owner_name = shift;
 if (defined ($owner_name) == 0 || $owner_name eq '') {
  my $cgi = new CGI;
  my $cookie = $cgi->cookie( -name => $var{user_cookie});
  unless (defined $cookie) {
   $var{user_rights} = $right{visitor};
  } else {
   $cookie = unmask ($cookie);	
   my ($user, $password) = split (/\//, $cookie);
   my ($lesen,%account);
   open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
   $lesen = <VERIFY>; close(VERIFY);
   %account = split(/\|/,$lesen); 

   unless (defined($user) == 0 || defined($password) == 0 ||
           defined($account{$user}) == 0 || $account{$user} ne $password) { 
    open(FILE, "< $var{right_file}") or error ('right_lookup'); 
    file_read();
    close(FILE);
    $x = 0;
    while ($x < @line) {
     my @temp = split(/\|/, $line[$x]);
     if ($temp[ $col{data} ] =~ /$user/i) {
      my $l_r = $col{rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
      if (defined ($l_r)) {
       $var{user_rights} = $l_r;
      } else { 
       $var{user_rights} = $right{visitor};
      } 
      $var{user} = $user; 
      $var{password} = $password;
     } 
     $x++;
    }   
   } else {
    $var{user_rights} = $right{visitor};
    $var{user} = 'unknown';
   }
  }
 } else {
  open(FILE, "< $var{right_file}") or error ('right_lookup'); 
  file_read();
  close(FILE);
  $x = 0;
  while ($x < @line) {
   my @temp = split(/\|/, $line[$x]);
   if ($temp[ $col{data} ] =~ /$owner_name/i) {
    my $l_r = $col {rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
    if (defined ($l_r)) {
     $var{user_rights} = $l_r;
    } else { 
     $var{user_rights} = $right{visitor};
    } 
   } 
   $x++;
  }   
 }
 my $r = $var{user_rights};
 $var{status} = $right[$r];
}

# Emailaddresse ueberpruefen

sub email_adresse_ueberpruefen {

  my $zu_testende_adresse = shift;
  $zu_testende_adresse =~ s/("(?:[^"\\]|\\.)*"|[^\t "]*)[ \t]*/$1/g;
  
  my $esc = '\\\\';
  my $leerzeichen = '\040';
  my $ctrl = '\000-\037';
  my $punkt = '\.';
  my $kein_ASCII = '\x80-\xff';
  my $umbruchliste = '\012\015';
  my $buchstabe = 'a-zA-Z';
  my $zahl = '\d';

  my $atomzeichen = qq{ [^$leerzeichen<>\@,;:".\\[\\]$esc$ctrl$kein_ASCII] };
  my $atom = qq{ $atomzeichen+ };
  my $byte = qq{ (?: 1?$zahl?$zahl |
                    2[0-4]$zahl    |
                    25[0-5]         ) };

  my $qtext = qq{ [^$esc$kein_ASCII$umbruchliste"] };
  my $quoted_pair = qq{ $esc [^$kein_ASCII] };
  my $quoted_str = qq{ " (?: $qtext | $quoted_pair )* " };
 
  my $wort = qq{ (?: $atom | $quoted_str ) };
  my $ip_adresse = qq{ \\[ $byte (?: $punkt $byte ){3} \\] };
  my $sub_domain = qq{ [$buchstabe$zahl]
                       [$buchstabe$zahl-]{0,61} [$buchstabe$zahl]};
  my $top_level = qq{ (?: $atomzeichen ){2,4} };
  my $domain_name = qq{ (?: $sub_domain $punkt ) + $top_level };
  my $domain = qq{ (?: $domain_name | $ip_adresse) };
  my $lokaler_teil = qq{ $wort (?: $punkt $wort )* };
  my $adresse = qq{ $lokaler_teil \@ $domain };

  return $zu_testende_adresse =~ /^$adresse$/ox ? $zu_testende_adresse : "";

}


###############
### Eingabe ###
###############


# Variablen aus einer Datei heraus initialisieren

sub load_var () {
 my $file = shift;	my $comment = 0;	my $array = 'var';	my $script = $var{script};
 file_open($file);
 file_read('x');
 file_close();
 $x = 0;
 while ($x < @line) {
  if ($comment == 1) {
   if ($line[$x] =~ /\*\//) {
    $line[$x] = $`;
   } else {
    $line[$x] = '';
   }
  } else {
   if ($line[$x] =~ /\#|\/\// && ($` !~ /\_\_/ && $' ne '') ) {
    $line[$x] = $`;
   }
   while ($line[$x] =~ /\/\*(.*?)\*\//) {
    $line[$x] = $` . $';
   }
   if ($line[$x] =~ /\/\*/) {
    $line[$x] = '';	$comment = 1;
   }
  }
  
  while ($line[$x] =~ /\s*\[script\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
   $script = $2;
   $line[$x] = $';
  }

  if ($line[$x] ne '' && $script eq $var{script}) {

   while ($line[$x] =~ /\s*\[array\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
    $array = $2;
    $line[$x] = $';
   }

   while ($line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*\_\_(.*?)\_\_[;|\n|\r]/ ||
          $line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*[\"|\']?(.*?)[\"|\']?[;|\n|\r]/) {

    my ($r_1,$r_2) = ($1,$3);

    if ($array eq 'var') {
     $var{$r_1} = $r_2;
    } elsif ($array eq 'error') {
     $error{$r_1} = $r_2;
    } elsif ($array eq 'log_detail') {
     $log_detail{$r_1} = $r_2;
    } elsif ($array eq 'home') {
     if (defined($home{$r_1}) && $home{$r_1} ne '') {
      $home{$r_1} = $home{$r_1} . ',' . $r_2;
     } else {
      $home{$r_1} = $r_2;
     }
    } elsif ($array eq 'right') {
     $right{$r_1} = $r_2;
     $right[$r_2] = $r_1;
    } elsif ($array eq 'spam') {
     $spam{$r_1} = $r_2;
    } elsif ($array eq 'find') {
     $find{$r_1} = $r_2;
    } elsif ($array eq 'match') {
     $match{$r_1} = $r_2;
    } elsif ($array eq 'comment') {
     $comment{$r_1} = $r_2;
    } elsif ($array eq 'standard') {
     $standard{$r_1} = $r_2;
    }  
    $line[$x] = $';
   }
  }
  $x++;
 }
}


sub file_open () {
 my ($file_name,$file_mode) = @_;

 if (defined ($file_mode)) {
  if ($file_mode =~ />>/ or $file_mode =~ /append/) {
   $file_mode = '>>';
  } elsif ($file_mode =~ /</ or $file_mode =~ /read/) {
   $file_mode = '<';
  } elsif ($file_mode =~ />/ or $file_mode =~ /write/) {
   $file_mode = '>';
  }
 } else {
  $file_mode = '<';
 }

 if ($file_mode eq '<' && -e $file_name == 0) {
  error('file_exist',$file_name);
 }

 if (-d $file_name) {
  error('file_directory',$file_name);
 }

 unless (open (FILE, "$file_mode $file_name")) {
  chmod (0706, $file_name) or error('file_open',$file_name);
  unless (open (FILE, "$file_mode $file_name")) {
   chmod (0766, $file_name) or error('file_open',$file_name);
   unless (open (FILE, "$file_mode $file_name")) {
    error('file_open',$file_name);
   }
  }
 }
 $file{name} = $file_name;
 $file{read} = 0;
}

sub file_read () {
 my $no_col = shift;
 @line = (); @col = (); %col = {}; 
 unless (defined $no_col) {
  $y = <FILE>; 	chomp($y); 	@col = split(/\|/, $y);	 
  $file{first} = $y;	$y = 0;
  while ($y < @col) {
   $col{ $col[$y] } = $y;
   $y++;
  }
 }
 $x = 0;
 while(<FILE>) {
  $line[$x] = $_; $x++;
 }
 if (defined $no_col) {
  $file{first} = $line[0];
 }
 $file{read} = 1;
}

sub file_close () {
 close (FILE) or error('file_close',$file{name});
}


###########################
### Formatkonvertierung ###
###########################


sub mask () {
 my $to_mask = shift;
 $to_mask =~ s/([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/\\$1/g;
 return $to_mask;
}

sub unmask () {
 my $to_unmask = shift;
 $to_unmask =~ s/\%20/ /g;
 while ($to_unmask =~ m/%(\w{2})/) {
  $to_unmask = $` . chr(hex($1)) . $';
 }  
 $to_unmask =~ s/%OA/<br>/g;   $to_unmask =~ s/\+/ /g;   $to_unmask =~ s/\n/<br>/g; 
 $to_unmask =~ s/\\([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/$1/g;
 return $to_unmask;
}

sub add_var() {
 my $to_add = shift;
 while ($to_add =~ /\$(\w+)/) {
  my $r = $var{$1};
  $to_add =~ s/\$$1/$r/g;
 }
 return $to_add;
}


###############
### Ausgabe ###
###############


# Fehlermeldungen generieren

sub error () {
 my @args = @_;
 my $error_code = $args[0];
 my $error_text;
 if (defined($error{$error_code})) {
  $error_text = $error{$error_code};
 } else {
  $error_text = $error{unknown};
 }
 $error_text =~ s/\$error_code/$error_code/g;
 while ($error_text =~ /\$(\d+)/) {
  $cur = $1;
  if ($cur < @args) {
   $args[$cur] =~ s/\$(\d+)//g;
   $error_text =~ s/\$$cur/$args[$cur]/g;
  } else {
   $error_text =~ s/\$$cur/\?/g;
  }
 }
 html($error_text);
}

# (Html-)Text ausgeben

sub html () {
 my $html = shift;
 print "Content-type: text/html\n\n";
 print $html;
 exit;
}