#!/usr/bin/perl -T


# Datum:	$Date: 2002/01/26 20:55:06 $
# Version: 	$Revision: 1.3 $
# Use:	free for non-commercial opensource-projects 

# Autor:	Dragonstorm
# Website:	www.dragon-codex.de
# Quakenet:	#dragon-codex


use strict;
use Fcntl qw/:flock/;
use CGI;
use CGI::Carp qw( fatalsToBrowser );


############################
### Variablendeklaration ###
############################


my (%query,%param,%var,%default,%right,@right,%home,%dataset,%sort,%type,%list,%first,%last,%log_detail,%mark,%error,%file,%col,@col,@line);

my (@e,@f,$x,$y,$cur,$valid,$var_name);

my (@elements,$laenge,$cache);

my ($field,$to_check,$to_select,$checking,$selecting,$difference,@search_elements,$most);

my $cgi = new CGI;

############################
### Variablenzuweisungen ###
############################


# Standardwerte

$file{read} = 0;
$var{query_string} = get_input($ENV{QUERY_STRING});
$cache = '';
$field = 'e';
$most = 0;
$difference = 0;

# Scriptname

if (defined ($ENV{SCRIPT_NAME}))  {
 $var{script} = $ENV{SCRIPT_NAME};
 while ($var{script} =~ /\//) {
  $var{script} = $';
 }
 $var{script} =~ /\./; $var{script} = $`;
} else {
 $var{script} = 'master';
}

# Datum

my @date = localtime(time()); 
$date [4]++; 
if ($date[1] < 10) { 
 $date[1] = '0' . $date[1]; 
}
$var{date} = $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900) 
                       . ' - ' . $date[2] . ':' . $date[1]; 


#######################
### Variablen laden ###
#######################


load_var('config.txt');


##############################
### Parameter ueberpruefen ###
##############################


# uebergebene Parameter

my (@param_rank) = ('dataset','search','skip','include','home');
my @parameter = split( /\+/, $ENV{QUERY_STRING} );

$x = 0;

while ($x < @parameter) {
 $parameter[$x] = unmask($parameter[$x]);
 if ($parameter[$x] =~ /\=/ && $` == '') {
  $param{$`} = $';
  $query{$`} = $';
 } else {
  $param{ $param_rank[$x] } = $parameter[$x];
  $query{ $param_rank[$x] } = $parameter[$x];
 }
 $x++;
}

# verschiedene Variablensets

if ( (defined ($cgi->param("home")) && $cgi->param("home") =~ /(\w+)/) || $ENV{QUERY_STRING} =~ /home\=(\w+)/){
 $cur = $1 . '.txt';	my $old_dir = $var{directory};
 load_var($cur);
 if ($var{directory} ne '') {
  foreach $var_name ( sort keys %var ) {
   $var{$var_name} =~ s/$old_dir/$var{directory}/g;
  }
 }
}

# Rechte initialisieren

get_rights();

# verschiedene Datensets

if (defined ($param{dataset})) {
 $valid = 0;
 @e = split(/\,/, $list{dataset});
 $x = 0; 
 my @prefixes = split(/,/ ,$first{dataset});
 while ($x < @e && $valid == 0) {
  $y = 0;
  while ($y < @prefixes) {
   my $possibility = $prefixes[$y] . $e[$x];
   if ($param{dataset} eq $possibility && defined ($dataset{$possibility}) == 1) {
    $valid = 1;
   }
   $y++;
  }
  $x++;
 }
 if ($valid == 1) {
  my $data_set = $param{dataset}; my $search_param;
  ($param{form},$param{data},$search_param) = split(/\,/, $dataset{ $data_set });
  if (defined ($search_param) ) { 
   $param{search} = $search_param;
   $param{search} = add_var($param{search}); 
   $param{search} =~ s/\_/\,/g;
  }
 } elsif (defined ($param{form}) == 0) {
  $param{form} = $param{dataset};
 }
}

# Parameter auf angegebene Typen pruefen

foreach $var_name ( sort keys %type ) {
 if ( defined $default{$var_name} ) {
  unless ( defined $param{$var_name} ) { 
   $param{$var_name} = $default{$var_name};
  }
  $valid = 0;
  if ( $type{$var_name} eq 'file' ) {
   $x = 0;   
   @e = split (/,/, $first{$var_name});
   @f = split (/,/, $last{$var_name});   $f[@f] = ''; 
   while ($x < @e && $valid == 0) {
    $y = 0;
    while ($y < @f && $valid == 0) {
     $cur = $e[$x] . $param{$var_name} . $f[$y];
     if (-e $cur && -d $cur == 0) {
      $valid = 1;
     }
     $y++;
    }
    $x++;
   }
  } elsif ( $type{$var_name} eq 'digit') {
   $cur = '';
   while ($param{$var_name} =~ /(\d+)/) {
    $param{$var_name} = $';
    $cur = $cur . $1;
   }
   if ($cur =~ /\d+/) {
    $valid = 1;
   }
  } elsif ( $type{$var_name} eq 'list') {
   @e = split(/\,/, $list{$var_name});
   $x = 0; 
   while ($x < @e) {
    if ($param{$var_name} eq $e[$x]) {
     $valid = 1;
    }
    $x++;
   } 
  } elsif ( $type{$var_name} eq 'boolean') {
   if ($param{$var_name} =~ /(\d+)/) {
    $param{$var_name} = $1;
    if ($param{$var_name} >= 1) {
     $cur = 1;
    } else {
     $cur = 0;
    }
    $valid = 1;
    } else {
    if ($param{$var_name} =~ /false/) {
     $cur = 0;
    } elsif ($param{$var_name} =~ /true/) {
     $cur = 1;
    } else {
     $cur = 0;
    }
    $valid = 1;
   }
  } elsif ( $type{$var_name} eq 'any') {
   $cur = $param{$var_name};
   $valid = 1;
  }
  unless ($valid == 1) {
   if (defined ($default{$var_name})) {
    $param{$var_name} = $default{$var_name};
   }
  } else {
   $param{$var_name} = $cur;
  }
 } 
}


########################################
### Aufruf in die Logdatei schreiben ###
########################################


if ($var{log} == 1) {
 $x = $var{log_detail};	$cur = ''; @e = ();
 if (defined ($log_detail{$x})) {
  @e = split(/,/, $log_detail{$x});
  $y = 0;
  while ($y < @e) {
   if ($y != 0) {
    $cur = $cur . ' [' . $var{ $e[$y] . ']' };
   }
   $y++;
  }  
 } else {
  $cur = '[' . $var{user} . '] 	[' . $var{script} . '] 		[' . $var{date} . '] 	[' . $ENV{QUERY_STRING} . ']';
 }
 file_open($var{log_file},'append');
 print FILE "$cur\n";
 file_close();
}


########################################
### User mit IP als online speichern ###
########################################


if ($var{record_online} == 1) {
 record_online();
}

##############################
### Parameter draw checken ###
##############################


if ($param{draw} ne '0' && $param{draw} ne '') {
 quit ($param{draw});
}


#################
### Hauptteil ###
#################


# Form laden

file_open($param{form});	file_read('no');	file_close();	

# Rechte fuer Form ueberpruefen

unless(check_rights()) {
 $x = $var{user_rights};
 $y = $right[$x];
 error('right_form',$y,$param{form});
}

if ($param{form} =~ /frames/) {

 # einfachen Frame laden

 $x = 0;   $cur = '';
 while ($x < @line) {
  $cur = $cur . $line[$x];
  $x++;
 }
 quit ($cur);

} else {

 # Daten laden

 my @line_temp = @line;
 file_open($param{data});	file_read();	file_close();

 unless(check_rights()) {
  $x = $var{user_rights};
  $y = $right[$x];
  error('right_data',$y,$param{data});
 }

 # Daten nach Suchkriterien eingrenzen

 search();

 @line = @line_temp;

 $y = @line;

 # Daten sortieren

 $x = -1;
 foreach $var_name (sort keys %sort) {
  if ($param{data} =~ /$var_name/) {
   $x = $var_name;
  }
 }

 if (defined($param{sort}) == 1 && $param{sort} =~ /,/) {
  $sort{$x} = $param{sort};
 }

 if (defined $sort{$x}) {

  my (%count,%get);

  @e = split(/,/, $sort{$x});

  if ($e[0] eq 'alphabet' && @e > 1) {

   # alphabetisch sortieren

   if ($e[1] =~ /\d+/ && $' eq '' && $` eq '') {
    $x = $&;
   } else {
    $x = $col{$e[1]};
   }
   $y = 0;	my (@to_sort,%to_sort);
   while ($y < @elements) {
    $cur = $elements [$y] [$x];
    $to_sort[$y] = $cur;

    if (defined($count{$cur}) == 0) {
     $to_sort{$cur} = $y;  $count{$cur} = 1;	$get{$cur} = 0;
    } else {
     $to_sort{$cur} = $to_sort{$cur} . '_' . $y;	$count{$cur}++;
    } 
    $y++;
   }
   @to_sort = sort { lc($a) cmp lc($b) } @to_sort;
   $y = 0;	my @cur_elements = @elements;
   while ($y < @to_sort) {
    $cur = $to_sort[$y];
    if ($count{$cur} == 1) {
     $x = $to_sort{$cur};
    } else {
     my @e = split(/_/, $to_sort{$cur});
     $x = $e[$get{$cur}];	$get{$cur}++;
    }
    @elements[$y] = $cur_elements[$x];
    $y++;
   }
   
  } elsif ($e[0] eq 'numerical' && @e > 1) {

   # numerisch sortieren

   if ($e[1] =~ /\d+/ && $' eq '' && $` eq '') {
    $x = $&;
   } else {
    $x = $col{$e[1]};
   }
   $y = 0;	my (@to_sort,%to_sort);
   while ($y < @elements) {
    $cur = $elements [$y] [$x];
    $to_sort[$y] = $cur;	

    if (defined($count{$cur}) == 0) {
     $to_sort{$cur} = $y;  $count{$cur} = 1;	$get{$cur} = 0;
    } else {
     $to_sort{$cur} = $to_sort{$cur} . '_' . $y;	$count{$cur}++;
    } 
    $y++;
   }
   @to_sort = sort { $b <=> $a } @to_sort;
   $y = 0;	my @cur_elements = @elements;

   while ($y < @to_sort) {
    $cur = $to_sort[$y];
    if ($count{$cur} == 1) {
     $x = $to_sort{$cur}; 
    } else {
     my @e = split(/_/, $to_sort{$cur});$x = @e;
     $x = $e[$get{$cur}];	$get{$cur}++;
    }
    @elements[$y] = $cur_elements[$x];
    $y++;
   }


  }

  $y = @line;	$valid = 0;

  # Beitrag der bestimme Bedingungen erfllt als default eintragen

  if (@e > 3) {

   if ($e[2] =~ /\d+/ && $' eq '' && $` eq '') {
    $cur = $&;
   } else {
    $cur = $col{$&};
   }

   $x = 0;

   while($x < $laenge && $valid == 0) {
    if ($elements[$x] [$cur] =~ m/$e[3]/i) {
     $cache = create(0, $y - 1, $x);  $x = $laenge;	$valid = 1;
    }
    $x++;
   }
   if ($valid == 0) {
    $cache = create(0, $y - 1, -1);
   }
  } else {
   $cache = create(0, $y - 1, -1);
  }

 } elsif ($e[0] eq 'oldest') {

  # die aeltesten Elemente zuerst anzeigen

  $cache = create(0, $y - 1, -1);

 } else {

  # die neusten Elemente zuerst anzeigen

  @elements = reverse(@elements);

  $cache = create(0, $y - 1, -1);

 }
}

# Ergebnis anzeigen

quit($cache);


###################
### Subroutinen ###
###################


# User als Online aufzeichnen

sub record_online () {

 file_open($var{stats_file});
 flock (FILE, LOCK_EX);
 file_read();
 
 $line[0] =~ s/\r|\n//g;	my @temp = split(/\|/, $line[0]);	$temp[0]++;

 my ($online_1,$line,@online,%online_user,@u,$v,$ip,$online_name,$online_status);

 @u = localtime(time());
 $v = $u[1] + ($u[2] * 60) + ($u[3] * 3600) + ($u[4] * 3600 * 24);
 open (ONLINE, "< $var{online_file}") or error ('online_view');
 $online_1 = <ONLINE>;
 while(<ONLINE>) {	push(@line,$_);	}
 $x = 0;
 while ($x < @line) {
  chomp($line[$x]);
  @online = split (/\|/, $line[$x]);
  if ($online[1] =~ /\d+/ && $v - $& < 300 && $v - $& >= 0) {
   $online_user { $online[0] } = "$online[1]\|$online[2]\|$online[3]\|$online[4]";
  }
  $x++;
 }
 close (ONLINE);
 undef(@line);
 $ip = $ENV{REMOTE_ADDR};
 
 if (defined ($online_user {$ip}) ) {
 
  @online = split (/\|/, $online_user {$ip});
 
  if ($param{online_name} ne '0' && $param{online_name} ne '') {
   $online_name = $param{online_name};
  } else {
   $online_name = $online[1];
  } 
 
  if ($param{online_status} ne '0' && $param{online_status} ne '') {
   $online_status =  $param{online_status};
  } else {
   if (defined ($param{dataset})) {
    $var_name = $param{dataset};
    if ($var_name !~ /\w+/) { 
     $var_name = 'news'; 
    }
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . $var_name . '</a>';
   } elsif (defined ($param{form})) {
    my @temp2 = split(/,/, $first{form});	$x = 0;	$cur = $param{form};
    while ($x < @temp2) {
     $temp2[$x] = mask($temp2[$x]);
     if ($param{form} =~ /$temp2[$x]/) { 
      $cur = $';	$x = @temp2;
     }
     $x++;
    }
    if ($cur =~ /\.html/) { 
     $cur = $`;
    }
    $var_name = $cur;	@temp2 = split(/,/, $first{data});	$x = 0;	$cur = $param{data};
    while ($x < @temp2) {
     $temp2[$x] = mask($temp2[$x]);
     if ($param{data} =~ /$temp2[$x]/) { 
      $cur = $';	$x = @temp2;
     }
     $x++;
    }
    if ($cur =~ /\.txt/) { 
     $cur = $`;
    }
    $var_name = $var_name . '+' . $cur;
    if ($var_name !~ /\w+/) { 
     $var_name = 'news'; 
    }
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . $var_name . '</a>';
   } else {
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . "unknown" . '</a>';
   }
   if ($online_status =~ /online/ || $online_status =~ /include\=0/ || $online_status =~ /draw\=/) {
    $online_status = $online[3];
   }
  }
  if (defined ($online_status) == 0 || $online_status !~ /\w+/ || $online_status =~ /\>\<\/a\>/) {
   $online_status = '<a href="load.pl?news" target="_blank">news</a>';
  }
 } else {
 
  $temp[1]++;

  if ($var{user_rights} > $right{visitor}) {
   $online_name = $var{user};
  } elsif ($param{online_name} ne '0' && $param{online_name} ne '') {
   $online_name = $param{online_name};
  } else {
   $online_name = "guest";
  }
 
  if ($param{online_status} ne '0' && $param{online_status} ne '') {
   $online_status =  $param{online_status};
  } else {
   if (defined ($param{dataset})) {
    $var_name = $param{dataset};
    if ($var_name !~ /\w+/) { 
     $var_name = 'news'; 
    }
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . $var_name . '</a>';
   } elsif (defined ($param{form})) {
    my @temp2 = split(/,/, $first{form});	$x = 0;	$cur = $param{form};
    while ($x < @temp2) {
     $temp2[$x] = mask($temp2[$x]);
     if ($param{form} =~ /$temp2[$x]/) { 
      $cur = $';	$x = @temp2;
     }
     $x++;
    }
    if ($cur =~ /\.html/) { 
     $cur = $`;
    }
    $var_name = $cur;	@temp2 = split(/,/, $first{data});	$x = 0;	$cur = $param{data};
    while ($x < @temp2) {
     $temp2[$x] = mask($temp2[$x]);
     if ($param{data} =~ /$temp2[$x]/) { 
      $cur = $';	$x = @temp2;
     }
     $x++;
    }
    if ($cur =~ /\.txt/) { 
     $cur = $`;
    }
    $var_name = $var_name . '+' . $cur;
    if ($var_name !~ /\w+/) { 
     $var_name = 'news'; 
    }
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . $var_name . '</a>';
   } else {
    $online_status = '<a href="load.pl?' . $ENV{QUERY_STRING} . '" target="_blank">' . "unknown" . '</a>';
   }
   if ($online_status =~ /online/ || $online_status =~ /include\=0/ || $online_status =~ /draw\=/) {
    $online_status = $online[3];
   }
  }
  if (defined ($online_status) == 0 || $online_status !~ /\w+/ || $online_status =~ /\>\<\/a\>/) {
   $online_status = '<a href="load.pl?news" target="_blank">news</a>';
  }
 }
 my $rr = $var{user_rights};
 $online_user {$ip} = "$v\|$online_name\|$right[$rr]\|$online_status";
 
 if ($online_1 !~ /\n/) { 
  $online_1 = $online_1 . "\n"; 
 } else {
  $online_1 =~ s/[\n|\r]{2,}/\n/g;
 }

 open (ONLINE, "> $var{online_file}") or error ('online_write');
 print ONLINE "$online_1";
 my $var_name;
 foreach $var_name ( sort keys %online_user ) {
  if ($var_name ne '127.0.0.1') {
   print ONLINE "$var_name\|$online_user{$var_name}\n";
  }
 }
 close (ONLINE);

 file_close(); 
 file_open ($var{stats_file},"write");
 flock (FILE, LOCK_EX);
 $file{first} =~ s/\r|\n//g; print FILE "$file{first}";
 print FILE "\n$temp[0]\|$temp[1]";	
 file_close();

}


################
### Wichtige ###
################


# Gewuenschte Ausgabe

sub quit () {
 my $insert = shift;
 my ($url,$urlx,$lines,@lines);
 $url = '';	$lines = 0;

 # Je nach Rechten User-Area um weitere Funktionen erweitern

 if ($param{form} =~ /user/) {

  if ($var{user_rights} >= $right{admin}) {
   $insert = $insert . $var{admin_area};
  }
 
  if ($var{user_rights} >= $right{operator}) {
   $insert = $insert . $var{operator_area};
  }
 }

 # Layout einlesen und generierte Ausgabe als Frame integrieren

 @lines = (); $lines = 0;

 if ($param{include} == 1) {
  open (FILE, "< $var{include_file}") or error('include_open',$var{include_file});
  while(defined ($cur = <FILE>)) {	
   if ($cur =~ /if(\d+)/) {
    if ( defined($elements[-1]) == 0 || defined($elements[-1] [$1]) == 0 || 
         $elements[-1] [$1] eq '' || $elements[-1] [$1] eq '0') {
     $cur = '';
    }
   } 
   $lines[$lines] = $cur;   $lines++;
   $url = $url . $cur;   
  }
  close(FILE) or error('include_close',$var{include_file});
 
  $url =~ s/\<\!\-\-\$dateiname\-\-\>/$insert/g;
 
 } else {
  $url = $insert;
 }

 # Integrierte Daten laden

 $urlx = $url;

 while ($urlx =~ /\<\!--\<load:(\w+):(.+?)\>--\>/) {
  $urlx = $'; @lines = split(/\n\r|\n\r|\n|\r/,$url);
  if (-e $2 && -d $1 == 0) {
   
   $field = $1;	
   file_open($2); file_read(); file_close();
   
   $laenge = 0;   $x = 0;   @elements = ();

   while($x < @line) {

    @e = ();  @e = split(/\|/,$line[$x]);  $y = 0; 
    @e = split(/\|/,$line[$x]);

    if ($field ne 'p' || $e[3] =~ /public/) {
     $y = 0;
     while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
     if ($field eq 'n') { 
      $elements[$laenge][1] =~ /.{0,10}/;	$cur = $&;
      if ($elements[$laenge][1] ne $cur) {
       $valid = 3;	$var_name = $cur;
       while ($var_name =~ /\.+/) {
        if ($' eq '') {
         if (length($&) > 3) {
          $valid = 0; 
         } else {
          $valid = 3 - length($&);
         }
        }
        $var_name = $';
       }
       $var_name = '';
       for ($y = 0; $y < $valid; $y++) {
        $var_name = $var_name . '.';
       }        
       $elements[$laenge][1] = $cur . $var_name;
      }
     }
     $laenge++;
    } 
 
    $x++;
   }
   @line = @lines;
   @elements = reverse(@elements);
   $x = 0; while ($x < @line) { $line[$x] = $line[$x] . "\n"; $x++; }
   if ($laenge > 0) {   
    $url = create_field(0, @line - 1, -1);
   }
  }
 }

 # In einer Datei enthaltenen Elemente zaehlen

 my $urlx = $url;
 while ($urlx =~ /\<\!--\<count(.+?)\>--\>/) {
  $cur = $&;	$var_name = $1;
  if (-e $var_name) { 
   open (COUNT, "< $var_name") or die("could'nt open $var_name");
   $x = 0;
   while (<COUNT>) {
    $x++;
   }
   close(COUNT);
   if ($x < 0 || $x !~ /\d+/) { $x = 0; }
   $url =~ s/$cur/$x/g;
  }
  $urlx = $';
 }

 my $urlx = $url;
 while ($urlx =~ /\<\!--\<counting(.+?)\>--\>/) {
  $cur = $&;	$var_name = $1;
  if (-e $var_name) { 
   open (COUNT, "< $var_name") or die("could'nt open $var_name");
   $x = -1;
   while (<COUNT>) {
    $x++;
   }
   close(COUNT);
   if ($x < 0 || $x !~ /\d+/) { $x = 0; }
   $url =~ s/$cur/$x/g;
  }
  $urlx = $';
 }

 my $urlx = $url;
 while ($urlx =~ /\<\!--\<counted(.+?)\>--\>/) {
  $cur = $&;	$var_name = $1;
  if (-e $var_name) { 
   open (COUNT, "< $var_name") or die("could'nt open $var_name");
   $x = -2;
   while (<COUNT>) {
    $x++;
   }
   close(COUNT);
   if ($x < 0 || $x !~ /\d+/) { $x = 0; }
   $url =~ s/$cur/$x/g;
  }
  $urlx = $';
 }

 $urlx = $url;

 # Zufaellige Auswahl aus vorgegebenen Moeglichkeiten

 while ($urlx =~ /(\<\!--\<rand__)(.*?)(__\>--\>)/) {
  $urlx = $';
  my $rfirst = $1; my $rlast = $3;
  my $random_parts = $2;
  if ($random_parts =~ /__/) {
   my @parts = split(/__/, $random_parts);
   my $random_number = int(rand @parts);
   $random_parts = mask ($random_parts);
   my $replace = $rfirst . $random_parts . $rlast;
   $url =~ s/$replace/$parts[$random_number]/g;
  }
 } 

 # alle Links, die auf die gerade angezeigte Seite verweisen, hervorheben

 my $script = $var{script} . '.pl';
 my $query_string = $var{query_string};
 my $call = $script . '?' .  $query_string; 
 $call =~ s/([\\|\||\(|\)|\[|\{|\^|\$|\*|\?|\.|\+])/\\$1/g;
 $url =~ s/\<(a.*?href\s*?\=\s*?\".*?$call\".*?)\>(.*?)(\<\/a\>)/\<$1 class="current"\>$2$3/g;

 # Datum ergaenzen

 if ($url =~ /\$datum/) {
  my @date = localtime(time()); $date [4]++; if ($date[1] < 10) { $date[1] = '0' . $date[1]; }
  my $full_date = $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900); 
  $url =~ s/<!--\$datum-->/$full_date/g;;
 }

 # Loginfeld bzw. User-Area-Links ergaenzen

 if ($var{user_rights} <= $right{visitor}) {
  my $log = $var{login_field};
  $url =~ s/<!--\$log_or_\$links-->/$log/g;
 } else {
  my $custom = $var{link_field};
  $url =~ s/<!--\$log_or_\$links-->/$custom/g;
 }

 # Variablen ergaenzen
 
 $url = substitute($url);

 # Links vervollstaendigen

 $url = complete_links($url);

 # einige Texte farbig hervorheben

 $x = 0; $valid = 1;
 @e = split(/,/, $var{no_replace});

 while ($x < @e) {
  if ($param{form} =~ /$e[$x]/) {
   $valid = 0;
  }
  $x++;
 }

 if ($valid) {
  foreach $var_name (sort keys %mark) {
   if ($param{form} =~ /$var_name/) {
    my %to_mark = split (/\,/, $mark{$var_name});
    foreach $cur (sort keys %to_mark) {
     $url =~ s/$cur/$to_mark{$cur}/g;
    }
   }
  }

  $var_name = 'all';

  if (defined ($mark{$var_name})) {

   my %to_mark = split (/\,/, $mark{$var_name});
   foreach $cur (sort keys %to_mark) {
    $url =~ s/$cur/$to_mark{$cur}/g;
   }
  }

  $var_name = 'home';

  if (defined ($mark{$var_name})) {

   my %to_mark = split (/\,/, $mark{$var_name});
   foreach $cur (sort keys %to_mark) {
    $url =~ s/$cur/$to_mark{$cur}/g;
   }
  }

 } else {

  $var_name = 'home';

  if (defined ($mark{$var_name})) {

   my %to_mark = split (/\,/, $mark{$var_name});
   foreach $cur (sort keys %to_mark) {
    $url =~ s/$cur/$to_mark{$cur}/g;
   }
  }
 }

 if (defined ($param{mark})) { 
  my %to_mark = split (/\,/, $param{mark});
  foreach $cur (sort keys %to_mark) {
   $to_mark{$cur} = unmask($to_mark{$cur}); 
   $url =~ s/$cur/$to_mark{$cur}/ig;
  }
 }

 # Quelltext bereinigen

 #$url =~ s/[\n|\r]/\n/g;
 $url =~ s/\<\!--.*?--\>//g;
 $url =~ s/\$e\[\d+\]//g;

 # Debuginformation hinzufuegen

 if ($param{debug} == 1) {
  debug();
  $url = "$url\n<!--$var{debug_info}-->";
 }

 html($url);
}

# Links vervollstaendigen

sub complete_links () {
 my $o_url = shift;
 my $c_url = $o_url;
 my ($found, $cur_c);

 while ($c_url =~ /[src|href|background|action|value]\s?\=\s?\"([^\"]+)\"/) {
  $c_url = $'; $found = $1;  
  $x = 0;   $valid = 0;
  @e = split (/,/, $first{links});
  while ($x < @e && $valid == 0) {
   $cur_c = $e[$x] . $found;
   if (-e $cur_c) {
    $valid = 1;
   }
   $x++;
  }
  if ($valid) {
   $o_url =~ s/([src|href|background|action]\s?\=\s?\")$found(\")/$1$cur_c$2/ig;
  }    
 }
 return $o_url;
}


# Dateirechte mit den Userrechten vergleichen

sub check_rights () {
 my %rights;
 my $script = $var{script} . '.pl';
 if ($file{first} =~ /\|/) {
  %rights = split(/,/, $col[-1]);
 } elsif ($file{first} =~ /\<\!\-\-(.*)\-\-\>/ && $file{first} =~ /,/) {
  $file{first} =~ /\<\!\-\-(.*)\-\-\>/;
  %rights = split(/,/, $1);
 } elsif ($file{first} =~ /,/) {
  %rights = split(/,/, $file{first});
 } else {
  $rights{$script} = $var{default_rights};
 }
 $rights{$script} =~ s/\s//g;
 $x = $rights{$script};
 $rights{$script} = $right{$x};
 if ($rights{$script} !~ /\d+/) {
  $rights{$script} = $var{default_rights};
 } 
 return compare_rights ($rights{$script});
}

sub compare_rights () {
 my $file_rights = shift;
 my @conditions = split(/,/, $file_rights);
 $x = 0;
 while ($x < @conditions) {
  if ($conditions[$x] =~ /\>\=\s*(\d+)/) {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\>\s*(\d+)/) {
   if ($var{user_rights} > $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\=\s*(\d+)/) {
   if ($var{user_rights} <= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\s*(\d+)/) {
   if ($var{user_rights} < $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\=\s*(\d+)/) {
   if ($var{user_rights} = $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /(\d+)/)  {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  }
  $x++;
 }
 return 0; 
}

# Ueberpruefung der Rechte mit Hilfe des gesetzen Cookies

sub get_rights () {

 $var{user_rights} = $right{visitor};
 my $owner_name = shift;
 if (defined ($owner_name) == 0 || $owner_name eq '') {
  my $cgi = new CGI;
  my $cookie = $cgi->cookie( -name => $var{user_cookie});
  unless (defined $cookie) {
   $var{user_rights} = $right{visitor};
  } else {
   $cookie = unmask ($cookie);	
   my ($user, $password) = split (/\//, $cookie);
   my ($lesen,%account);
   open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
   $lesen = <VERIFY>; close(VERIFY);
   %account = split(/\|/,$lesen); 

   unless (defined($user) == 0 || defined($password) == 0 ||
           defined($account{$user}) == 0 || $account{$user} ne $password) { 
    open(FILE, "< $var{right_file}") or error ('right_lookup'); 
    file_read();
    close(FILE);
    $x = 0;
    while ($x < @line) {
     my @temp = split(/\|/, $line[$x]);
     if ($temp[ $col{data} ] =~ /$user/i) {
      my $l_r = $col{rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
      if (defined ($l_r)) {
       $var{user_rights} = $l_r;
      } else { 
       $var{user_rights} = $right{visitor};
      } 
      $var{user} = $user; 
      $var{password} = $password;
     } 
     $x++;
    }   
   } else {
    $var{user_rights} = $right{visitor};
    $var{user} = 'unknown';
   }
  }
 } else {
  open(FILE, "< $var{right_file}") or error ('right_lookup'); 
  file_read();
  close(FILE);
  $x = 0;
  while ($x < @line) {
   my @temp = split(/\|/, $line[$x]);
   if ($temp[ $col{data} ] =~ /$owner_name/i) {
    my $l_r = $col {rights};	$l_r = $temp[$l_r];	$l_r = right{$l_r};
    if (defined ($l_r)) {
     $var{user_rights} = $l_r;
    } else { 
     $var{user_rights} = $right{visitor};
    } 
   } 
   $x++;
  }   
 }
 my $r = $var{user_rights};
 $var{status} = $right[$r];
}

# Daten den Suchkriterien entsprechend filtern

sub search () {
 my $compare = 1;
 my (%search,@search);
 if (defined $param{search}) {
  $param{search} = $param{search};
  %search = split (/,/, $param{search});
  foreach $var_name (sort keys %search) {
   if ($var_name =~ /\d+/ && $` eq '' && $' eq '') {
    $search[$var_name] = $search{$var_name};
   } else {
    $x = $col{$var_name};
    $search[$x] = $search{$var_name};
   }
  }
 } elsif ($param{name} ne '' && $param{value} ne '') {
 
  my @names = split (/,/, $param{name});
  my @values = split (/,/, $param{value});
  $x = 0;

  while ($x < @names && $x < @values) {
 
   $names [$x] = mask($names [$x]);
   $values [$x] = mask($values [$x]);
   if ($values [$x] =~ /\\\?/) {
    $values [$x] = $`;
   }
   if ($values [$x] =~ /\?/) {
    $values [$x] = $`;
   }
    
   if ($names [$x] =~ /\d+/ && $` eq '' && $' eq '') {	
    $search[ $names[$x] ] = $values [$x];	
   } else {  

    $cur = $col{ $names[$x] };	
    $search[$cur] = $values [$x];	
   }  $x++;
  }
 } else {
  $compare = 0;
 } 

 $x = 0;	$laenge = 0;

 while($x < @line) {

  @e = ();		@e = split(/\|/,$line[$x]);

  if ($compare) {
   $y = 0; 
   while ($y < @e) {
    $e[$y] = mask($e[$y]); $y++;
   }
   $y = 0;
   while ($y < @e && (defined($search[$y]) == 0 || $e[$y] =~ /$search[$y]/i || $e[$y] eq $search[$y] || 
          ($search[$y] =~ /\s+/ && $` eq '' && $' eq '')) ) {	
    $y++; 
   } 

   @e = split(/\|/,$line[$x]);
   if ($y == @e) {
    $y = 0;
    while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
    $laenge++;
   }
  } else {
   $y = 0;
   while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
   $laenge++;
  }
  $x++;
 } 
}


# Laden der Daten

sub create_field () {

  my ($p1,$p2,$p3) = @_;

  my ($first,$repeat,$last,$count,$c,$b,$value,$max,$n,
      $start_number,$end_number,$begin,$end);

  $value = '';	$param{skip} = 0;

  for ($c = $p1; $c <= $p2; $c++) {

    if ($line[$c] =~ m/<$field:start(\d+)-(\d+)>/) {
  
      $begin = $1; 		$end = $2;

      if (($end - $begin) > $difference) {        $difference = $end - $begin;      }

      if ($end > $most) {        $most = $end;      }

      $b = $c;
 
      $end_number = 0;	$start_number = 1;

      while ($end_number < $start_number) {
        $b++; 
        if ($line[$b] =~ /<$field:start/) { 	$start_number++; 	}
        if ($line[$b] =~ /<$field:end/) { 	$end_number++; 	}                   
      } 

      if (($begin + $param{skip}) >= 0 && $begin <= $end 
       && ($begin + $param{skip}) <= $laenge) {

        $max = 0;

        if (($end + $param{skip}) < $laenge) {          $max = $end + $param{skip};

        } else {          $max = $laenge;        }

        for ($n = $begin + $param{skip}; $n < $max; $n++) {
          unless ($n == $p3) {
            $value = $value . create_field ($c + 1, $b - 1, $n);
          }  
        }     
      }

      $c = $b;

    } else {
      $value = $value . substitute_field($line[$c], $p3);
    }      
  }

  return $value;

}

sub substitute_field () { 

 my ($ergebnis,$zugriff) = @_;
 my ($first_s,$last_s,$position,$g,$sub,$add,$buffer);
 my $status;

 my $r = $var{user_rights};
 $status = $right[$r];

 unless (defined @elements[$zugriff]) { 

  $ergebnis =~ s/\$$field\[(\d+)]//g;

 } else {  

  while ($ergebnis =~ /value=\"?\$$field\[(\d+)]\"?>/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $sub =~ s/\"/\&\#34\;/g;	$sub = 'value="' . $sub . '">';
   $ergebnis = $first_s . $sub . $last_s;
  }

  while ($ergebnis =~ /\"\$$field\[(\d+)]\"/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $sub =~ s/\"/\&\#34\;/g;
   $ergebnis = $first_s . $sub . $last_s;
  }

  while ($ergebnis =~ /\$$field\[(\d+)]/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $ergebnis = $first_s . $sub . $last_s;
  }
 }

 my ($script,$call,$last_skip,$next_skip,$last_call,$next_call);

 $script = $var{script} . '.pl'; 
 $call = $script . '?' .  $var{query_string};

 $last_skip = $param{skip} - $difference;
 $next_skip = $param{skip} + $difference;
 if ($last_skip < 0) {	$last_skip = 0;	}
 if ($next_skip >= $laenge) {	$next_skip = $param{skip};	}
 $last_call = $call;	$next_call = $call;
 if ($last_call =~ /skip\=\d+/) {
  $last_call =~ s/skip\=\d+/skip\=$last_skip/g;
 } else {
  $last_call = "$call\+skip\=$last_skip";
 }
 if ($next_call =~ /skip\=\d+/) {
  $next_call =~ s/skip\=\d+/skip\=$next_skip/g;
 } else {
  $next_call = "$call\+skip\=$next_skip";
 }
 $ergebnis =~ s/\$last/$last_call/g;
 $ergebnis =~ s/\$this/$call/g;
 $ergebnis =~ s/\$next/$next_call/g;

 $ergebnis =~ s/\$form/$query{form}/g;
 $ergebnis =~ s/\$daten/$param{data}/g;
 $ergebnis =~ s/\$data/$query{data}/g;
 $ergebnis =~ s/\$custom/$param{custom}/g;
 $ergebnis =~ s/\$user/$var{user}/g;
 $ergebnis =~ s/\$password/$var{password}/g;
 $ergebnis =~ s/\$status/$var{status}/g;
 $ergebnis =~ s/\$time/$var{date}/g;
 $ergebnis =~ s/\$loop/$zugriff/g;
  
 my $r = @elements;
 $ergebnis =~ s/\$anzahl/$r/g;

  if ($ergebnis =~ /if$field(\d+)/) {
   if ( defined $elements[$zugriff] == 0 || $elements[$zugriff] [$1] eq '' || $elements[$zugriff] [$1] eq ' ' || $elements[$zugriff] [$1] eq '0') {
    $ergebnis = '';
   }
  }

  if ($ergebnis =~/\<\!--\<$field:search(\d+)\:(.+)\>--\>/) {
   my ($search_num,$search_value) = ($1,$2);
   $x = 0; $y = 0; undef(@search_elements); 
   while ($x < @elements) {
    if ($elements[$x][$search_num] =~ /$search_value/i) { 
     @search_elements[$y] = @elements[$x];
     $y++;
    }
    $x++;
   }
   my @backup_elements = @elements; 
   undef(@elements); @elements = @search_elements;
   @search_elements = @backup_elements;
   $laenge = $y;
  }

  if ($ergebnis =~/\<\!--\<\/search\>--\>/) {
   undef(@elements); @elements = @search_elements;
   $laenge = @elements;
  }
  
 return $ergebnis;

}

sub create () {

  my ($p1,$p2,$p3) = @_;

  my ($first,$repeat,$last,$count,$c,$b,$value,$max,$n,
      $start_number,$end_number,$begin,$end);

  $value = '';

  for ($c = $p1; $c <= $p2; $c++) {

    if ($line[$c] =~ m/<start(\d+)-(\d+)>/) { 

      $begin = $1; 		$end = $2;

      if (($end - $begin) > $difference) {        $difference = $end - $begin;      }

      if ($end > $most) {        $most = $end;      }

      $b = $c;
 
      $end_number = 0;	$start_number = 1;

      while ($end_number < $start_number) {
        $b++; 
        if ($line[$b] =~ /<start/) { 	$start_number++; 	}
        if ($line[$b] =~ /<end/) { 	$end_number++; 	}                   
      } 

      if (($begin + $param{skip}) >= 0 && $begin <= $end 
       && ($begin + $param{skip}) <= $laenge) {

        $max = 0;

        if (($end + $param{skip}) < $laenge) {          $max = $end + $param{skip};

        } else {          $max = $laenge;        }

        for ($n = $begin + $param{skip}; $n < $max; $n++) {
          unless ($n == $p3) {
            $value = $value . create ($c + 1, $b - 1, $n);
          }  
        }     
      }

      $c = $b;

    } else {
      $value = $value . substitute($line[$c], $p3);
    }      
  }

  return $value;

}

# Variablen in den Daten durch ihre Werte ersetzen

sub substitute () { 

 my ($ergebnis,$zugriff) = @_;
 my ($first_s,$last_s,$position,$g,$sub,$add,$buffer);
 my $status;

 my $r = $var{user_rights};
 $status = $right[$r];

 unless (defined @elements[$zugriff]) { 

  $ergebnis =~ s/\$$field\[(\d+)]//g;

 } else {  

  while ($ergebnis =~ /value=\"?\$$field\[(\d+)]\"?/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $sub =~ s/\"/\&\#34\;/g;	$sub = 'value="' . $sub . '"';
   $ergebnis = $first_s . $sub . $last_s;
  }

  while ($ergebnis =~ /\"\$$field\[(\d+)]\"/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $sub =~ s/\"/\&\#34\;/g;
   $ergebnis = $first_s . $sub . $last_s;
  }

  while ($ergebnis =~ /\$$field\[(\d+)]/) {
   $first_s = $`; $last_s = $'; 
   $position = $1;
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   if ($param{form} =~ /change/) { $sub =~ s/\<br\>/\n/g; }
   $ergebnis = $first_s . $sub . $last_s;
  }
 }

 my ($script,$call,$last_skip,$next_skip,$last_call,$next_call);

 $script = $var{script} . '.pl'; 
 $call = $script . '?' .  $var{query_string};
 $last_skip = $param{skip} - $difference;
 $next_skip = $param{skip} + $difference;
 if ($last_skip < 0) {	$last_skip = 0;	}
 if ($next_skip >= $laenge) {	$next_skip = $param{skip};	}
 $last_call = $call;	$next_call = $call;
 if ($last_call =~ /skip\=\d+/) {
  $last_call =~ s/skip\=\d+/skip\=$last_skip/g;
 } else {
  $last_call = "$call\+skip\=$last_skip";
 }
 if ($next_call =~ /skip\=\d+/) {
  $next_call =~ s/skip\=\d+/skip\=$next_skip/g;
 } else {
  $next_call = "$call\+skip\=$next_skip";
 }
 $ergebnis =~ s/\$last/$last_call/g;
 $ergebnis =~ s/\$this/$call/g;
 $ergebnis =~ s/\$next/$next_call/g;

 $ergebnis =~ s/\$form/$query{form}/g;
 $ergebnis =~ s/\$daten/$param{data}/g;
 $ergebnis =~ s/\$data/$query{data}/g;
 $ergebnis =~ s/\$custom/$param{custom}/g;
 $ergebnis =~ s/\$user/$var{user}/g;
 $ergebnis =~ s/\$password/$var{password}/g;
 $ergebnis =~ s/\$status/$var{status}/g;
 $ergebnis =~ s/\$time/$var{date}/g;
 $ergebnis =~ s/\$loop/$zugriff/g;
  
 my $r = $laenge;
 $ergebnis =~ s/\$anzahl/$r/g;

 $buffer = $ergebnis;

 while ($buffer =~ /\$(\w+)/) {

  $first_s = $`; $last_s = $';    $position = $1;    $y = 0;  

  if (defined ($col{$position}) ) {
   $position = $col{$position};
   $sub = $elements[$zugriff] [$position];
   while ($sub =~ /\n/) { $sub = $` . $'; }
   $ergebnis = s/$position/$sub/g;
  }  

  $buffer = $last_s;

 }

  if ($ergebnis =~/\<\!--\<search(\d+)\:(.+)\>--\>/) {
   my ($search_num,$search_value) = ($1,$2);
   $x = 0; $y = 0; undef(@search_elements); 
   while ($x < @elements) {
    if ($elements[$x][$search_num] =~ /$search_value/i) { 
     @search_elements[$y] = @elements[$x];
     $y++;
    }
    $x++;
   }
   my @backup_elements = @elements; 
   undef(@elements); @elements = @search_elements;
   @search_elements = @backup_elements;
   $laenge = $y;
  }

  if ($ergebnis =~/\<\!--\<\/search\>--\>/) {
   undef(@elements); @elements = @search_elements;
   $laenge = @elements;
  }
 

 if ($field eq 'e') {

  if ($ergebnis =~ /\<check([\w|,]+)\>/) {
   $to_check = $1;	$checking = 1;	$ergebnis = $` . $';
   if ($to_check =~ /,/) {  $to_check = $`;   }
  }

  if ($checking) {
   if ($ergebnis =~ /value=\"$to_check\"/) {
    $ergebnis = $` . "value\=$to_check checked" . $';
    $checking = 0;
   }
  }

  if ($ergebnis =~ /\<select([\w|,]+)\>/) {
   $to_select = $1;	$selecting = 1;	$ergebnis = $` . $';
   if ($to_select =~ /,/) {  $to_select = $';   }
  }

  if ($selecting) {
   if ($ergebnis =~ /value=\"$to_select\"/) {
    $ergebnis = $` . "value\=$to_select selected" . $';
    $selecting = 0;
   }
  }

  if ($ergebnis =~ /if(\d+)/) {
   if ( defined $elements[$zugriff] == 0 || $elements[$zugriff] [$1] eq '0' || $elements[$zugriff] [$1] !~ /\d|\w/) {
    $ergebnis = '';
   }
  }
 }
  
 return $ergebnis;

}


###############
### Eingabe ###
###############


# Variablen aus einer Datei heraus initialisieren

sub load_var () {
 my $file = shift;	my $comment = 0;	my $array = 'var';	my $script = $var{script};
 file_open($file);
 file_read('x');
 file_close();
 $x = 0;
 while ($x < @line) {
  if ($comment == 1) {
   if ($line[$x] =~ /\*\//) {
    $line[$x] = $`;
   } else {
    $line[$x] = '';
   }
  } else {
   if ($line[$x] =~ /\#|\/\// && ($` !~ /\_\_/ && $' ne '') ) {
    $line[$x] = $`;
   }
   while ($line[$x] =~ /\/\*(.*?)\*\//) {
    $line[$x] = $` . $';
   }
   if ($line[$x] =~ /\/\*/) {
    $line[$x] = '';	$comment = 1;
   }
  }
  
  while ($line[$x] =~ /\s*\[script\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
   $script = $2;
   $line[$x] = $';
  }

  if ($line[$x] ne '' && $script eq $var{script}) {

   while ($line[$x] =~ /\s*\[array\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
    $array = $2;
    $line[$x] = $';
   }

   while ($line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*\_\_(.*?)\_\_[;|\n|\r]/ ||
          $line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*[\"|\']?(.*?)[\"|\']?[;|\n|\r]/) {

    my ($r_1,$r_2) = ($1,$3);

    if ($array eq 'var') {
     $var{$r_1} = $r_2;
    } elsif ($array eq 'error') {
     $error{$r_1} = $r_2;
    } elsif ($array eq 'default') {
     $default{$r_1} = $r_2;
    } elsif ($array eq 'type') {
     $type{$r_1} = $r_2;
    } elsif ($array eq 'list') {
     $list{$r_1} = $r_2;
    } elsif ($array eq 'first') {
     $first{$r_1} = $r_2;
    } elsif ($array eq 'last') {
     $last{$r_1} = $r_2;
    } elsif ($array eq 'log_detail') {
     $log_detail{$r_1} = $r_2;
    } elsif ($array eq 'home') {
     if (defined($home{$r_1}) && $home{$r_1} ne '') {
      $home{$r_1} = $home{$r_1} . ',' . $r_2;
     } else {
      $home{$r_1} = $r_2;
     }
    } elsif ($array eq 'dataset') {
     $dataset{$r_1} = $r_2;
    } elsif ($array eq 'sort') {
     $sort{$r_1} = $r_2;
    } elsif ($array eq 'right') {
     $right{$r_1} = $r_2;
     $right[$r_2] = $r_1;
    } elsif ($array eq 'mark') {
     $mark{$r_1} = $r_2;
    }
    $line[$x] = $';
   }
  }
  $x++;
 }
}


sub file_open () {
 my ($file_name,$file_mode) = @_;

 if (defined ($file_mode)) {
  if ($file_mode =~ />>/ or $file_mode =~ /append/) {
   $file_mode = '>>';
  } elsif ($file_mode =~ /</ or $file_mode =~ /read/) {
   $file_mode = '<';
  } elsif ($file_mode =~ />/ or $file_mode =~ /write/) {
   $file_mode = '>';
  }
 } else {
  $file_mode = '<';
 }

 if ($file_mode eq '<' && -e $file_name == 0) {
  error('file_exist',$file_name);
 }

 if (-d $file_name) {
  error('file_directory',$file_name);
 }

 unless (open (FILE, "$file_mode $file_name")) {
  chmod (0706, $file_name) or error('file_open',$file_name);
  unless (open (FILE, "$file_mode $file_name")) {
   chmod (0766, $file_name) or error('file_open',$file_name);
   unless (open (FILE, "$file_mode $file_name")) {
    error('file_open',$file_name);
   }
  }
 }
 $file{name} = $file_name;
 $file{read} = 0;
}

sub file_read () {
 my $no_col = shift;
 @line = (); @col = (); %col = {}; 
 unless (defined $no_col) {
  $y = <FILE>; 	chomp($y); 	@col = split(/\|/, $y);	 
  $file{first} = $y;	$y = 0;
  while ($y < @col) {
   $col{ $col[$y] } = $y;
   $y++;
  }
 }
 $x = 0;
 while(<FILE>) {
  $line[$x] = $_; $x++;
 }
 if (defined $no_col) {
  $file{first} = $line[0];
 }
 $file{read} = 1;
}

sub file_close () {
 close (FILE) or error('file_close',$file{name});
}


###########################
### Formatkonvertierung ###
###########################


sub get_input () {
 my $to_unmask = shift;
 $to_unmask =~ s/\%20/ /g;
 while ($to_unmask =~ m/%(\w{2})/) {
  $to_unmask = $` . chr(hex($1)) . $';
 }  
 $to_unmask =~ s/%OA/<br>/g;   $to_unmask =~ s/\n/<br>/g; 
 $to_unmask =~ s/\\([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/$1/g;
 return $to_unmask;
}

sub mask () {
 my $to_mask = shift;
 $to_mask =~ s/\\/\\\\/g;
 $to_mask =~ s/([\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/\\$1/g;
 return $to_mask;
}

sub unmask () {
 my $to_unmask = shift;
 $to_unmask =~ s/\%20/ /g;
 while ($to_unmask =~ m/%(\w{2})/) {
  $to_unmask = $` . chr(hex($1)) . $';
 }  
 $to_unmask =~ s/%OA/<br>/g;   $to_unmask =~ s/\+/ /g;   $to_unmask =~ s/\n/<br>/g; 
 $to_unmask =~ s/\\([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/$1/g;
 return $to_unmask;
}

sub add_var() {
 my $to_add = shift;
 while ($to_add =~ /\$(\w+)/) {
  my $r = $var{$1};
  $to_add =~ s/\$$1/$r/g;
 }
 return $to_add;
}

###############
### Ausgabe ###
###############


# Debuginformationen generieren

sub debug () {

 my $description = '';
 if (defined($var{debug_info})) { 
  undef ($var{debug_info});
 }

 $description = $description . "\nPARAM\n\n";
 foreach $var_name ( sort keys %param ) {
  $description = $description .  " $var_name = $param{$var_name}\n";
 }

 $description = $description . "\nVAR\n\n";
 foreach $var_name ( sort keys %var ) {
  $description = $description . " $var_name = $var{$var_name}\n";
 }

 $description = $description . "\nLIST\n\n";
 foreach $var_name ( sort keys %list ) {
  $description = $description . " $var_name = $list{$var_name}\n";
 }

 $description = $description . "\nTYPE\n\n";
 foreach $var_name ( sort keys %type ) {
  $description = $description . " $var_name = $type{$var_name}\n";
 }

 $description = $description . "\nDEFAULT\n\n";
 foreach $var_name ( sort keys %default ) {
  $description = $description . " $var_name = $default{$var_name}\n";
 }

 $description = $description . "\nFIRST\n\n";
 foreach $var_name ( sort keys %first ) {
  $description = $description . " $var_name = $first{$var_name}\n";
 }

 $description = $description . "\nLAST\n\n";
 foreach $var_name ( sort keys %last ) {
  $description = $description . " $var_name = $last{$var_name}\n";
 }

 $description = $description . "\nDATASET\n\n";
 foreach $var_name ( sort keys %dataset ) {
  $description = $description . " $var_name = $dataset{$var_name}\n";
 }

 $description = $description . "\nHOME\n\n";
 foreach $var_name ( sort keys %home ) {
  $description = $description . " $var_name = $home{$var_name}\n";
 }

 $description = $description . "\nRIGHT\n\n";
 foreach $var_name ( sort keys %right ) {
  $description = $description . " $var_name = $right{$var_name}\n";
 }

 $var{debug_info} = $description;

}

# Fehlermeldungen generieren

sub error () {
 my @args = @_;
 my $error_code = $args[0];
 my $error_text;
 if (defined($error{$error_code})) {
  $error_text = $error{$error_code};
 } else {
  $error_text = $error{unknown};
 }
 $error_text =~ s/\$error_code/$error_code/g;
 while ($error_text =~ /\$(\d+)/) {
  $cur = $1;
  if ($cur < @args) {
   $args[$cur] =~ s/\$(\d+)//g;
   $error_text =~ s/\$$cur/$args[$cur]/g;
  } else {
   $error_text =~ s/\$$cur/\?/g;
  }
 }
 html($error_text);
}

# (Html-)Text ausgeben

sub html () {
 my $html = shift;
 print "Content-type: text/html\n\n";
 print $html;
 exit;
}