#!/usr/bin/perl -T


# Datum:	$Date: 2002/01/03 19:25:49 $
# Version: 	$Revision: 1.2 $
# Use:	free for non-commercial opensource-projects 

# Autor:	Dragonstorm
# Website:	www.dragon-codex.de
# Quakenet:	#dragon-codex


use strict;
use Fcntl qw/:flock/;
use CGI;
use CGI::Carp qw( fatalsToBrowser );


############################
### Variablendeklaration ###
############################


my (%param,%var,%right,@right,%home,%log_detail,%error,%file,%col,@col,@line);

my (@e,@f,$x,$y,$cur,$valid,$var_name);

my $cgi = new CGI;

############################
### Variablenzuweisungen ###
############################


# Standardwerte

$file{read} = 0;
$var{query_string} = unmask($ENV{QUERY_STRING});

# Scriptname

if (defined ($ENV{SCRIPT_NAME}))  {
 $var{script} = $ENV{SCRIPT_NAME};
 while ($var{script} =~ /\//) {
  $var{script} = $';
 }
 $var{script} =~ /\./; $var{script} = $`;
} else {
 $var{script} = 'master';
}

# Datum

my @date = localtime(time()); 
$date [4]++; 
if ($date[1] < 10) { 
 $date[1] = '0' . $date[1]; 
}
$var{date} = $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900) 
                       . ' - ' . $date[2] . ':' . $date[1]; 


#######################
### Variablen laden ###
#######################


load_var('config.txt');


##############################
### Parameter ueberpruefen ###
##############################


# verschiedene Variablensets

if ( (defined ($cgi->param("home")) && $cgi->param("home") =~ /(\w+)/) || $ENV{QUERY_STRING} =~ /home\=(\w+)/){
 $cur = $1 . '.txt';	my $old_dir = $var{directory};
 load_var($cur);
 if ($var{directory} ne '') {
  foreach $var_name ( sort keys %var ) {
   $var{$var_name} =~ s/$old_dir/$var{directory}/g;
  }
 }
}

# Rechte initialisieren

get_rights();


########################################
### Aufruf in die Logdatei schreiben ###
########################################


if ($var{log} == 1) {
 $x = $var{log_detail};	$cur = ''; @e = ();
 if (defined ($log_detail{$x})) {
  @e = split(/,/, $log_detail{$x});
  $y = 0;
  while ($y < @e) {
   if ($y != 0) {
    $cur = $cur . ' [' . $var{ $e[$y] . ']' };
   }
   $y++;
  }  
 } else {
  $cur = '[' . $var{user} . ']	[' . $var{script} . '] 	[' . $var{date} . '] 	[' . $ENV{QUERY_STRING} . ']';
 }
 file_open($var{log_file},'append');
 print FILE "$cur\n";
 file_close();
}


#################
### Hauptteil ###
#################


# Rechte pruefen

$var{user_rights} = $right{visitor};

my ($user, $password) = ($cgi->param("user"),$cgi->param("password"));
my ($lesen,%account);
open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
$lesen = <VERIFY>; close(VERIFY);
%account = split(/\|/,$lesen); 

unless (defined($user) == 0 || defined($password) == 0 ||
        defined($account{$user}) == 0 || $account{$user} ne $password) { 
 open(FILE, "< $var{right_file}") or error ('right_lookup'); 
 file_read();
 close(FILE);
 $x = 0;
 while ($x < @line) {
  my @temp = split(/\|/, $line[$x]);
  if ($temp[ $col{data} ] =~ /$user/i) {
   my $l_r = $col{rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
   if (defined ($l_r)) {
    $var{user_rights} = $l_r;
   } else { 
    $var{user_rights} = $right{visitor};
   } 
   $var{user} = $user; 
   $var{password} = $password;
  } 
  $x++;
 }   
} else {
 $var{user_rights} = $right{visitor};
 $var{user} = 'unknown';
}
my $r = $var{user_rights};
$var{status} = $right[$r];

unless ($var{user_rights} > $right{visitor} && $var{user} eq $cgi->param("user") && $var{password} eq $cgi->param("password")) {
 error ('invalid_kombination',$cgi->param("user"),$cgi->param("password"));
} else {
 
 # Cookie setzen

 unless ( defined ($cgi->param($var{time})) ) {

  $cgi->param($var{time} => $var{default_time});

 }

 my $server = $ENV{HTTP_HOST};	$server =~ /www\./;	$server = $';

 my $cookie = $cgi->cookie( -name   => $var{user_cookie},
                             -value  => "$var{user}/$var{password}", 
                             -path   => "/cgi-bin/",
                             -expires => $cgi->param($var{time}),
                             -domain => $server) or error ('no_cookies');

 print "Set-Cookie: $cookie\n";

 # Cookie testen lassen
 
 $cur = "test_login\.pl\?$var{user}/$var{password}";

 if (defined($cgi->param("home")) && $cgi->param("home") =~ /\w+/) {
  $cur = $cur .  '+home=' . $cgi->param("home");
 }

 my $redirection = $cgi->redirect(	-url    => $cur,
                                    -cookie => $cookie);

 print $redirection;  

}


################
### Wichtige ###
################


# Gewuenschte Ausgabe

sub quit () {

 my $text = shift;
 my $redirection;
  
 if (defined($cgi->param("home")) && $cgi->param("home") =~ /\w+/) {
  $cur = $cgi->param("home");
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text+home=$cur");
 } else {
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text");
 }

 print $redirection;  
 exit;

}

# Dateirechte mit den Userrechten vergleichen

sub check_rights () {
 my %rights;
 my $script = $var{script} . '.pl';
 if ($file{first} =~ /\|/) {
  %rights = split(/,/, $col[-1]);
 } elsif ($file{first} =~ /\<\!\-\-(.*)\-\-\>/ && $file{first} =~ /,/) {
  $file{first} =~ /\<\!\-\-(.*)\-\-\>/;
  %rights = split(/,/, $1);
 } elsif ($file{first} =~ /,/) {
  %rights = split(/,/, $file{first});
 } else {
  $rights{$script} = $var{default_rights};
 }
 $rights{$script} =~ s/\s//g;
 $x = $rights{$script};
 $rights{$script} = $right{$x};
 if ($rights{$script} !~ /\d+/) {
  $rights{$script} = $var{default_rights};
 } 
 return compare_rights ($rights{$script});
}

sub compare_rights () {
 my $file_rights = shift;
 my @conditions = split(/,/, $file_rights);
 $x = 0;
 while ($x < @conditions) {
  if ($conditions[$x] =~ /\>\=\s*(\d+)/) {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\>\s*(\d+)/) {
   if ($var{user_rights} > $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\=\s*(\d+)/) {
   if ($var{user_rights} <= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\s*(\d+)/) {
   if ($var{user_rights} < $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\=\s*(\d+)/) {
   if ($var{user_rights} = $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /(\d+)/)  {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  }
  $x++;
 }
 return 0; 
}

# Ueberpruefung der Rechte mit Hilfe des gesetzen Cookies

sub get_rights () {

 $var{user_rights} = $right{visitor};
 my $owner_name = shift;
 if (defined ($owner_name) == 0 || $owner_name eq '') {
  my $cgi = new CGI;
  my $cookie = $cgi->cookie( -name => $var{user_cookie});
  unless (defined $cookie) {
   $var{user_rights} = $right{visitor};
  } else {
   $cookie = unmask ($cookie);	
   my ($user, $password) = split (/\//, $cookie);
   my ($lesen,%account);
   open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
   $lesen = <VERIFY>; close(VERIFY);
   %account = split(/\|/,$lesen); 

   unless (defined($user) == 0 || defined($password) == 0 ||
           defined($account{$user}) == 0 || $account{$user} ne $password) { 
    open(FILE, "< $var{right_file}") or error ('right_lookup'); 
    file_read();
    close(FILE);
    $x = 0;
    while ($x < @line) {
     my @temp = split(/\|/, $line[$x]);
     if ($temp[ $col{data} ] =~ /$user/i) {
      my $l_r = $col{rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
      if (defined ($l_r)) {
       $var{user_rights} = $l_r;
      } else { 
       $var{user_rights} = $right{visitor};
      } 
      $var{user} = $user; 
      $var{password} = $password;
     } 
     $x++;
    }   
   } else {
    $var{user_rights} = $right{visitor};
    $var{user} = 'unknown';
   }
  }
 } else {
  open(FILE, "< $var{right_file}") or error ('right_lookup'); 
  file_read();
  close(FILE);
  $x = 0;
  while ($x < @line) {
   my @temp = split(/\|/, $line[$x]);
   if ($temp[ $col{data} ] =~ /$owner_name/i) {
    my $l_r = $col {rights};	$l_r = $temp[$l_r];	$l_r = right{$l_r};
    if (defined ($l_r)) {
     $var{user_rights} = $l_r;
    } else { 
     $var{user_rights} = $right{visitor};
    } 
   } 
   $x++;
  }   
 }
 my $r = $var{user_rights};
 $var{status} = $right[$r];
}


###############
### Eingabe ###
###############


# Variablen aus einer Datei heraus initialisieren

sub load_var () {
 my $file = shift;	my $comment = 0;	my $array = 'var';	my $script = $var{script};
 file_open($file);
 file_read('x');
 file_close();
 $x = 0;
 while ($x < @line) {
  if ($comment == 1) {
   if ($line[$x] =~ /\*\//) {
    $line[$x] = $`;
   } else {
    $line[$x] = '';
   }
  } else {
   if ($line[$x] =~ /\#|\/\// && ($` !~ /\_\_/ && $' ne '') ) {
    $line[$x] = $`;
   }
   while ($line[$x] =~ /\/\*(.*?)\*\//) {
    $line[$x] = $` . $';
   }
   if ($line[$x] =~ /\/\*/) {
    $line[$x] = '';	$comment = 1;
   }
  }
  
  while ($line[$x] =~ /\s*\[script\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
   $script = $2;
   $line[$x] = $';
  }

  if ($line[$x] ne '' && $script eq $var{script}) {

   while ($line[$x] =~ /\s*\[array\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
    $array = $2;
    $line[$x] = $';
   }

   while ($line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*\_\_(.*?)\_\_[;|\n|\r]/ ||
          $line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*[\"|\']?(.*?)[\"|\']?[;|\n|\r]/) {

    my ($r_1,$r_2) = ($1,$3);

    if ($array eq 'var') {
     $var{$r_1} = $r_2;
    } elsif ($array eq 'error') {
     $error{$r_1} = $r_2;
    } elsif ($array eq 'log_detail') {
     $log_detail{$r_1} = $r_2;
    } elsif ($array eq 'home') {
     if (defined($home{$r_1}) && $home{$r_1} ne '') {
      $home{$r_1} = $home{$r_1} . ',' . $r_2;
     } else {
      $home{$r_1} = $r_2;
     }
    } elsif ($array eq 'right') {
     $right{$r_1} = $r_2;
     $right[$r_2] = $r_1;
    } 
    $line[$x] = $';
   }
  }
  $x++;
 }
}


sub file_open () {
 my ($file_name,$file_mode) = @_;

 if (defined ($file_mode)) {
  if ($file_mode =~ />>/ or $file_mode =~ /append/) {
   $file_mode = '>>';
  } elsif ($file_mode =~ /</ or $file_mode =~ /read/) {
   $file_mode = '<';
  } elsif ($file_mode =~ />/ or $file_mode =~ /write/) {
   $file_mode = '>';
  }
 } else {
  $file_mode = '<';
 }

 if ($file_mode eq '<' && -e $file_name == 0) {
  error('file_exist',$file_name);
 }

 if (-d $file_name) {
  error('file_directory',$file_name);
 }

 unless (open (FILE, "$file_mode $file_name")) {
  chmod (0706, $file_name) or error('file_open_' . $file_mode . $file_name,$file_name);
  unless (open (FILE, "$file_mode $file_name")) {
   chmod (0766, $file_name) or error('file_open',$file_name);
   unless (open (FILE, "$file_mode $file_name")) {
    error('file_open',$file_name);
   }
  }
 }
 $file{name} = $file_name;
 $file{read} = 0;
}

sub file_read () {
 my $no_col = shift;
 @line = (); @col = (); %col = {}; 
 unless (defined $no_col) {
  $y = <FILE>; 	chomp($y); 	@col = split(/\|/, $y);	 
  $file{first} = $y;	$y = 0;
  while ($y < @col) {
   $col{ $col[$y] } = $y;
   $y++;
  }
 }
 $x = 0;
 while(<FILE>) {
  $line[$x] = $_; $x++;
 }
 if (defined $no_col) {
  $file{first} = $line[0];
 }
 $file{read} = 1;
}

sub file_close () {
 close (FILE) or error('file_close',$file{name});
}


###########################
### Formatkonvertierung ###
###########################


sub mask () {
 my $to_mask = shift;
 $to_mask =~ s/([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/\\$1/g;
 return $to_mask;
}

sub unmask () {
 my $to_unmask = shift;
 $to_unmask =~ s/\%20/ /g;
 while ($to_unmask =~ m/%(\w{2})/) {
  $to_unmask = $` . chr(hex($1)) . $';
 }  
 $to_unmask =~ s/%OA/<br>/g;   $to_unmask =~ s/\+/ /g;   $to_unmask =~ s/\n/<br>/g; 
 $to_unmask =~ s/\\([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/$1/g;
 return $to_unmask;
}

sub add_var() {
 my $to_add = shift;
 while ($to_add =~ /\$(\w+)/) {
  my $r = $var{$1};
  $to_add =~ s/\$$1/$r/g;
 }
 return $to_add;
}


###############
### Ausgabe ###
###############


# Fehlermeldungen generieren

sub error () {
 my @args = @_;
 my $error_code = $args[0];
 my $error_text;
 if (defined($error{$error_code})) {
  $error_text = $error{$error_code};
 } else {
  $error_text = $error{unknown};
 }
 $error_text =~ s/\$error_code/$error_code/g;
 while ($error_text =~ /\$(\d+)/) {
  $cur = $1;
  if ($cur < @args) {
   $args[$cur] =~ s/\$(\d+)//g;
   $error_text =~ s/\$$cur/$args[$cur]/g;
  } else {
   $error_text =~ s/\$$cur/\?/g;
  }
 }
 html($error_text);
}

# (Html-)Text ausgeben

sub html () {
 my $html = shift;
 print "Content-type: text/html\n\n";
 print $html;
 exit;
}