#!/usr/bin/perl -T


# Datum:	$Date: 2002/01/03 19:14:24 $
# Version: 	$Revision: 1.3 $
# Use:	free for non-commercial opensource-projects 

# Autor:	Dragonstorm
# Website:	www.dragon-codex.de
# Quakenet:	#dragon-codex


use strict;
use Fcntl qw/:flock/;
use CGI;
use CGI::Carp qw( fatalsToBrowser );


############################
### Variablendeklaration ###
############################


my (%param,%var,%right,@right,%home,%log_detail,%error,%file,%col,@col,@line);

my (@e,@f,$x,$y,$cur,$valid,$var_name);

my (@elements,$laenge);

my $cgi = new CGI;

my (%match,%find,$file,$tags,$position);

############################
### Variablenzuweisungen ###
############################


# Standardwerte

$file{read} = 0;
$var{query_string} = unmask($ENV{QUERY_STRING});
$tags = 0;

# Scriptname

if (defined ($ENV{SCRIPT_NAME}))  {
 $var{script} = $ENV{SCRIPT_NAME};
 while ($var{script} =~ /\//) {
  $var{script} = $';
 }
 $var{script} =~ /\./; $var{script} = $`;
} else {
 $var{script} = 'master';
}

# Datum

my @date = localtime(time()); 
$date [4]++; 
if ($date[1] < 10) { 
 $date[1] = '0' . $date[1]; 
}
$var{date} = $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900) 
                       . ' - ' . $date[2] . ':' . $date[1]; 


#######################
### Variablen laden ###
#######################


load_var('config.txt');


##############################
### Parameter ueberpruefen ###
##############################


# verschiedene Variablensets

if ( (defined ($cgi->param("home")) && $cgi->param("home") =~ /(\w+)/) || $ENV{QUERY_STRING} =~ /home\=(\w+)/){
 $cur = $1 . '.txt';	my $old_dir = $var{directory};
 load_var($cur);
 if ($var{directory} ne '') {
  foreach $var_name ( sort keys %var ) {
   $var{$var_name} =~ s/$old_dir/$var{directory}/g;
  }
 }
}

# Rechte initialisieren

get_rights();


########################################
### Aufruf in die Logdatei schreiben ###
########################################


if ($var{log} == 1) {
 $x = $var{log_detail};	$cur = ''; @e = ();
 if (defined ($log_detail{$x})) {
  @e = split(/,/, $log_detail{$x});
  $y = 0;
  while ($y < @e) {
   if ($y != 0) {
    $cur = $cur . ' [' . $var{ $e[$y] . ']' };
   }
   $y++;
  }  
 } else {
  $cur = '[' . $var{user} . ']	[' . $var{script} . '] 		[' . $var{date} . '] 	[' . $ENV{QUERY_STRING} . ']';
 }
 file_open($var{log_file},'append');
 print FILE "$cur\n";
 file_close();
}


#########################
# Dateinamen berprfen #
#########################


if (defined($cgi->param("file")) ) {
 $file = $cgi->param("file");
} else {
 error ('no_file');
}

unless (-e $file && -d $file == 0) {
 error('file_exist',$file);
}

$x = 0;	$valid = 0;		my @files = split(/,/, $var{poll_files}); 

while ($x < @files) {
 if ($file eq $files[$x]) {
  $file = $files[$x];
  $valid = 1;
 }
 $x++;
}

unless ($valid) {
 error('no_poll',$file);  
} 


#################
### Hauptteil ###
#################


# Datei laden

file_open($file);	file_read();	file_close();	

# Rechte fuer die Datei ueberpruefen

unless(check_rights()) {
 $x = $var{user_rights};
 $y = $right[$x];
 error('right_file',$y,$file);
}

# Auf gleiche Eintrge pruefen

$x = search('find');

if ($x == 0) {
 error('no_entry');
} elsif ($x > 1) {
 error('more_entries',$laenge);
}

if (search('leave') > 0) {
 error('match_entry',$laenge);
}

# Datum abfragen

@date = localtime(time()); $date [4]++; if ($date[1] < 10) { $date[1] = '0' . $date[1]; }
my $full_info = $date[2]. '.' . $date[1] . '.'. $date[3] . '.' . $date[4] . '.' . ($date[5] + 1900); 

my ($sub_vote, $to_add, $to_dis, $zahl, $his, $mode);

$to_add = 1; $to_dis = -1;

$cgi->param($var{modify}) =~ /\d+/; $cgi->param( $var{modify} => $&);

$full_info = $full_info . '.' . $cgi->param($var{modify});

$his = $var{history};	$his = $col{$his};
$mode = $var{mode};	$mode = $col{$mode};

# Auf internen Poll pruefen

if ($elements[0] [$mode] !~ /public/ && $var{user_rights} <= $right{visitor}) {
 error('poll_intern');
}

# Vote registrieren

if ($elements[0] [$mode] =~ /public/) {

 # oeffentliche Abstimmung

 $sub_vote = $ENV{REMOTE_ADDR} . ',' . $full_info;

 my (%old_votes,%new_votes,@old_date,@new_date);

 # alte Votes loeschen

 %old_votes = split (/,/, $elements[0] [$his]);

 foreach $var_name (sort keys %old_votes) {

  @old_date = split (/\./,$old_votes{$var_name}); @new_date = split (/\./,$full_info);
  my $sum1 = ($new_date[4] * 12 * 30 * 24 * 60) + 
             ($new_date[3] * 30 * 24 * 60) + 
             ($new_date[2] * 24 * 60) + 
             ($new_date[0] * 60) + 
              $new_date[1];
  my $sum2 = ($old_date[4] * 12 * 30 * 24 * 60) + 
             ($old_date[3] * 30 * 24 * 60) + 
             ($old_date[2] * 24 * 60) + 
             ($old_date[0] * 60) + 
              $old_date[1];
   
  if ($sum1 - $sum2 < $var{poll_sec}) {
   $new_votes{$var_name} = $old_votes{$var_name};
  }
 }

 $elements[0] [$his] = '';

 foreach $var_name (sort keys %new_votes) {
  $elements[0] [$his] = $elements[0] [$his] . $var_name . ',' . $new_votes{$var_name};
 }

 # Pruefen ob bereis gevotet wurde

 $cur = $ENV{REMOTE_ADDR};

 if (defined ($new_votes{$cur}) == 1) {
  @old_date = split (/\./,$new_votes{$cur}); @new_date = split (/\./,$full_info);
  my $sum1 = ($new_date[4] * 12 * 30 * 24 * 60) + 
             ($new_date[3] * 30 * 24 * 60) + 
             ($new_date[2] * 24 * 60) + 
             ($new_date[0] * 60) + 
              $new_date[1];
  my $sum2 = ($old_date[4] * 12 * 30 * 24 * 60) + 
             ($old_date[3] * 30 * 24 * 60) + 
             ($old_date[2] * 24 * 60) + 
             ($old_date[0] * 60) + 
              $old_date[1];
   
  if ($sum1 - $sum2 < $var{poll_sec}) {
   error('already_voted');
  }
 }
} else {

 # interne Abstimmung

 my @array_x; my $max_votes; my $votes; my @vote; my $voted;
 
 $var{user} =~ s/,//g;   $sub_vote = $var{user} . ',' . $full_info;
  
 if ($elements[0] [$his] =~ /$var{user}/) {
  $elements[0] [$mode] =~ /\d+/; $max_votes = $&;
  for ($x = 0; $x < 20; $x++) {
   $vote[$x] = 0;
  }
  my $matching = $elements[0] [$his];
  while ($matching =~ /$var{user}\,([\d|\.]+)\,/) { 
   @array_x = split(/\./,$&); $voted = $array_x[5];
   $vote[$voted]++;  
   $matching = $'; 
  }
  if ($matching =~ /$var{user}\,([\d|\.]+)/) {
   @array_x = split(/\./,$&); $voted = $array_x[5];
   $vote[$voted]++;
  }
  $votes = 0;
  for ($x = 0; $x < 20; $x++) {
   if ($vote[$x] > 0) {
    $votes++;
   }
  }

  my @new_date = split (/\./,$full_info);
   
  $new_date[5] =~ /\d+/; $voted = $&;

  if ($vote[$voted] > 0) {
 
   # Der User hat schon mal fuer das Selbe gevotet

   $to_add = 0;

  } elsif ($votes >= $max_votes) {

   # Der User hat schon die maximale Anzahl an Votes gemacht

   error('already_voted');

   if ( defined($cgi->param($var{reset})) == 0 || $cgi->param($var{reset}) !~ /\d+/) {

    # Den User einen Vote waehlen lassen, den er rueckgaengig machen will

    file_open($var{poll_change});
    my $urlx = ''; my $linex; while (defined($linex = <FILE>)) {     $urlx = $urlx . $linex;    }	
    file_close();
    $urlx =~ s/\$(\d+)/$vote[$1]/g;
    @array_x = @elements[0];
    $urlx =~ s/\$e\[(\d+)\]/$elements[0][$1]/g;
    my $mod = $cgi->param($var{modify});
    $urlx =~ s/\$modify/$mod/g;
    $urlx =~ s/\s+/\s/g;	$urlx =~ s/\n|\r+/\n/g;
 
    quit($urlx);

   } else { 

    # Den gewaehlten Vote ruckgaengig machen

    $cgi->param($var{reset}) =~ /\d+/; $to_dis = $&;
    my $to_search = 1; $matching = $elements[0] [$his];
    
    while ($matching =~ /$var{user}\,([\d|\.]+)\,/ && $to_search == 1) {
     $matching = $';
     @array_x = split(/\./,$&); $voted = $array_x[5];
     if ($to_dis == $voted) {
      $elements[0] [$his] = $` . $';
      $elements[0] [$his] =~ s/\,\,/\,/g;
      $to_search = 0;
     } 
    }
    if ($to_search == 1) { 
     $matching =~ /$var{user}\,([\d|\.]+)/;
     @array_x = split(/\./,$&); $voted = $array_x[5];
     if ($to_dis == $voted) {
      $elements[0] [$his] = $` . $';
      $elements[0] [$his] =~ s/\,\,/\,/g;
     } else {
       error ('select_voted'); 
     }
    }
   }
  }
 }
}

# jetzigen Vote speichern

if ($elements[0] [$his] !~ /,/) {
 $elements[0] [$his] = $elements[0] [$his] . $sub_vote;
} else {
 $elements[0] [$his] = $elements[0] [$his] . ',' . $sub_vote;
}


# Eintrag aendern

$zahl = $cgi->param($var{modify});

$cur = '';	my @elem = split(/\|/, $file{first});	$x = 0;
  
while ($x < @elem) {  

 $elem[$x] =~ s/[\s|\r|\n]//g;

 if ($x != 0) { 
  $cur = $cur . "\|";
 }

 if ( $elem[$x] =~ /$var{option}/ && $elem [$x] =~ /\d+/ && $& == $zahl) {
  my $number_x = $elements[0] [$x] + $to_add;
  $cur = $cur . $number_x; 
 } elsif ($elem[$x] =~ /$var{option}/ && $elem [$x] =~ /\d+/ && $& == $to_dis) {
  my $number_x = $elements[0] [$x] - 1;
  $cur = $cur . $number_x; 
 } else {
  $cur = $cur . $elements[0] [$x];
 } 

 $x++;
}

$line[$position] = "$cur\n";
$line[$position] =~ s/\n{2,}/\n/g;

# geaenderten Eintrag in die Datei schreiben

file_open($file,'write');	flock (FILE, LOCK_EX);
$file{first} =~ s/\r|\n//g; print FILE "$file{first}";	$x = 0;
while ($x < @line) {
 $line[$x] =~ s/\r|\n//g;
 print FILE "\n$line[$x]";
 $x++;
}
file_close();

quit ("Vote-command successfull!");


###################
### Subroutinen ###
###################


# Daten den Suchkriterien entsprechend filtern

sub search () {
 my $old = shift;
 my $compare = 1;
 my (%search,@search,$to_be_equal,$matched);

 $to_be_equal = -1;

 foreach $var_name (sort %find) {
  if ($file =~ /$var_name/i) {
   $to_be_equal = $match{$var_name};
   $x = 0; @e = split(/,/, $find{$var_name});
   while ($x < @e) {
    $y = $col{ $e[$x] };	$cur = $e[$x];
    if (defined($old) == 1) {
     $search[$y] = get_input ( $cgi->param($var{old} . $cur) );
    } else {
     $search[$y] = get_input ( $cgi->param($cur) );
    }
    $x++;
   }
  }
 }

 if ($to_be_equal == -1) {
  $var_name = 'default';
  $to_be_equal = $match{$var_name};
  $x = 0; @e = split(/,/, $find{$var_name});
  while ($x < @e) {
   $y = $col{ $e[$x] };	$cur = $e[$x];
   if (defined($old) == 1 && $old eq 'find') {
    $search[$y] = get_input ( $cgi->param($var{old} . $cur) );
   } else {
    $search[$y] = get_input ( $cgi->param($cur) );
   }
   $x++;
  }
 }

 $x = 0;	$laenge = 0;

 while($x < @line) {

  @e = ();		@e = split(/\|/,$line[$x]);

  if ($compare) {
   $y = 0;	$matched = 0;
   while ($y < @e) {
    if (defined($search[$y]) == 1 && $e[$y] eq $search[$y]) {
     $matched++;
    }	
    $y++; 
   }
   @e = split(/\|/,$line[$x]);
   if ($matched >= $to_be_equal) {
    if (defined($old) == 1 && $old eq 'find') {
     $position = $x;
    }
    unless (defined($old) == 1 && $old eq 'leave' && $x == $position) { 
     $y = 0;
     while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
     $laenge++;
    }
   }
 
  } else {
   $y = 0;
   while ($y < @e) {	$elements[$laenge] [$y] = $e[$y]; 	$y++;	}
   $laenge++;
  }
  $x++;
 } 
 
 if ($to_be_equal > 0) {
  return $laenge;
 } else {
  return 100;
 }
}


################
### Wichtige ###
################


# Sonderzeichen ersetzen

sub get_input () {
 my $thing = shift;
 my ($h,$sub,$pruef);
 while ($thing =~ m/%(\w{2})/) {
  $h = $1;
  $sub = chr(hex($h)); $thing = $` . $sub . $';
 }  
 $thing =~ s/%OA/<br>/g; $thing =~ s/\+/ /g; 
 $thing =~ s/\n/<br>/g;
 $thing =~ s/\n//g; $thing =~ s/\r//g;
 $thing =~ s/\?/\&\#063\;/g;  $thing =~ s/\{/\&\#123\;/g;  
 $thing =~ s/\^/\&\#94\;/g;   
 $thing =~ s/\|/\&\#124\;/g;    
 $thing =~ s/\[/\&\#091\;/g;  $thing =~ s/\$/\&\#36\;/g;  
 #$thing =~ s/\(/\&\#40\;/g;  $thing =~ s/\)/\&\#41\;/g;  
 #$thing =~ s/\#/\&\#43\;/g;  $thing =~ s/\//\&\#47\;/g;
 #$thing =~ s/\./\&\#46\;/g;
 unless ($tags) {
  $pruef = $thing; 
  $thing =~ s/</&lt;/g;
  $thing =~ s/&lt;br>/<br>/g;
  if ($thing ne $pruef) {
   error ('tags');
  }
 }
 return $thing;
}



# Gewuenschte Ausgabe

sub quit () {

 my $text = shift;
 my $redirection;
 if (defined($cgi->param("home")) && $cgi->param("home") =~ /\w+/) {
  $cur = $cgi->param("home");
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text+home=$cur");
 } else {
  $redirection = $cgi->redirect( -url => "load.pl?draw=$text");
 }

 print $redirection;  
 exit;

}

# Dateirechte mit den Userrechten vergleichen

sub check_rights () {
 my %rights;
 my $script = $var{script} . '.pl';
 if ($file{first} =~ /\|/) {
  %rights = split(/,/, $col[-1]);
 } elsif ($file{first} =~ /\<\!\-\-(.*)\-\-\>/ && $file{first} =~ /,/) {
  $file{first} =~ /\<\!\-\-(.*)\-\-\>/;
  %rights = split(/,/, $1);
 } elsif ($file{first} =~ /,/) {
  %rights = split(/,/, $file{first});
 } else {
  $rights{$script} = $var{default_rights};
 }
 $rights{$script} =~ s/\s//g;
 $x = $rights{$script};
 $rights{$script} = $right{$x};
 if ($rights{$script} !~ /\d+/) {
  $rights{$script} = $var{default_rights};
 } 
 return compare_rights ($rights{$script});
}

sub compare_rights () {
 my $file_rights = shift;
 my @conditions = split(/,/, $file_rights);
 $x = 0;
 while ($x < @conditions) {
  if ($conditions[$x] =~ /\>\=\s*(\d+)/) {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\>\s*(\d+)/) {
   if ($var{user_rights} > $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\=\s*(\d+)/) {
   if ($var{user_rights} <= $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\<\s*(\d+)/) {
   if ($var{user_rights} < $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /\=\s*(\d+)/) {
   if ($var{user_rights} = $1) {
    return 1; 
   }
  } elsif ($conditions[$x] =~ /(\d+)/)  {
   if ($var{user_rights} >= $1) {
    return 1; 
   }
  }
  $x++;
 }
 return 0; 
}

# Ueberpruefung der Rechte mit Hilfe des gesetzen Cookies

sub get_rights () {

 $var{user_rights} = $right{visitor};
 my $owner_name = shift;
 if (defined ($owner_name) == 0 || $owner_name eq '') {
  my $cgi = new CGI;
  my $cookie = $cgi->cookie( -name => $var{user_cookie});
  unless (defined $cookie) {
   $var{user_rights} = $right{visitor};
  } else {
   $cookie = unmask ($cookie);	
   my ($user, $password) = split (/\//, $cookie);
   my ($lesen,%account);
   open(VERIFY, "< $var{password_file}") or error ('right_verify'); 
   $lesen = <VERIFY>; close(VERIFY);
   %account = split(/\|/,$lesen); 

   unless (defined($user) == 0 || defined($password) == 0 ||
           defined($account{$user}) == 0 || $account{$user} ne $password) { 
    open(FILE, "< $var{right_file}") or error ('right_lookup'); 
    file_read();
    close(FILE);
    $x = 0;
    while ($x < @line) {
     my @temp = split(/\|/, $line[$x]);
     if ($temp[ $col{data} ] =~ /$user/i) {
      my $l_r = $col{rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
      if (defined ($l_r)) {
       $var{user_rights} = $l_r;
      } else { 
       $var{user_rights} = $right{visitor};
      } 
      $var{user} = $user; 
      $var{password} = $password;
     } 
     $x++;
    }   
   } else {
    $var{user_rights} = $right{visitor};
    $var{user} = 'unknown';
   }
  }
 } else {
  open(FILE, "< $var{right_file}") or error ('right_lookup'); 
  file_read();
  close(FILE);
  $x = 0;
  while ($x < @line) {
   my @temp = split(/\|/, $line[$x]);
   if ($temp[ $col{data} ] =~ /$owner_name/i) {
    my $l_r = $col {rights};	$l_r = $temp[$l_r];	$l_r = $right{$l_r};
    if (defined ($l_r)) {
     $var{user_rights} = $l_r;
    } else { 
     $var{user_rights} = $right{visitor};
    } 
   } 
   $x++;
  }   
 }
 my $r = $var{user_rights};
 $var{status} = $right[$r];
}

# Emailaddresse ueberpruefen

sub email_adresse_ueberpruefen {

  my $zu_testende_adresse = shift;
  $zu_testende_adresse =~ s/("(?:[^"\\]|\\.)*"|[^\t "]*)[ \t]*/$1/g;
  
  my $esc = '\\\\';
  my $leerzeichen = '\040';
  my $ctrl = '\000-\037';
  my $punkt = '\.';
  my $kein_ASCII = '\x80-\xff';
  my $umbruchliste = '\012\015';
  my $buchstabe = 'a-zA-Z';
  my $zahl = '\d';

  my $atomzeichen = qq{ [^$leerzeichen<>\@,;:".\\[\\]$esc$ctrl$kein_ASCII] };
  my $atom = qq{ $atomzeichen+ };
  my $byte = qq{ (?: 1?$zahl?$zahl |
                    2[0-4]$zahl    |
                    25[0-5]         ) };

  my $qtext = qq{ [^$esc$kein_ASCII$umbruchliste"] };
  my $quoted_pair = qq{ $esc [^$kein_ASCII] };
  my $quoted_str = qq{ " (?: $qtext | $quoted_pair )* " };
 
  my $wort = qq{ (?: $atom | $quoted_str ) };
  my $ip_adresse = qq{ \\[ $byte (?: $punkt $byte ){3} \\] };
  my $sub_domain = qq{ [$buchstabe$zahl]
                       [$buchstabe$zahl-]{0,61} [$buchstabe$zahl]};
  my $top_level = qq{ (?: $atomzeichen ){2,4} };
  my $domain_name = qq{ (?: $sub_domain $punkt ) + $top_level };
  my $domain = qq{ (?: $domain_name | $ip_adresse) };
  my $lokaler_teil = qq{ $wort (?: $punkt $wort )* };
  my $adresse = qq{ $lokaler_teil \@ $domain };

  return $zu_testende_adresse =~ /^$adresse$/ox ? $zu_testende_adresse : "";

}


###############
### Eingabe ###
###############


# Variablen aus einer Datei heraus initialisieren

sub load_var () {
 my $file = shift;	my $comment = 0;	my $array = 'var';	my $script = $var{script};
 file_open($file);
 file_read('x');
 file_close();
 $x = 0;
 while ($x < @line) {
  if ($comment == 1) {
   if ($line[$x] =~ /\*\//) {
    $line[$x] = $`;
   } else {
    $line[$x] = '';
   }
  } else {
   if ($line[$x] =~ /\#|\/\// && ($` !~ /\_\_/ && $' ne '') ) {
    $line[$x] = $`;
   }
   while ($line[$x] =~ /\/\*(.*?)\*\//) {
    $line[$x] = $` . $';
   }
   if ($line[$x] =~ /\/\*/) {
    $line[$x] = '';	$comment = 1;
   }
  }
  
  while ($line[$x] =~ /\s*\[script\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
   $script = $2;
   $line[$x] = $';
  }

  if ($line[$x] ne '' && $script eq $var{script}) {

   while ($line[$x] =~ /\s*\[array\]\s*(=|:|:=|\-\>)\s*(.*?)[;|\n|\r]/) {
    $array = $2;
    $line[$x] = $';
   }

   while ($line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*\_\_(.*?)\_\_[;|\n|\r]/ ||
          $line[$x] =~ /\s*(\S+)\s*(=|:|:=|\-\>)\s*[\"|\']?(.*?)[\"|\']?[;|\n|\r]/) {

    my ($r_1,$r_2) = ($1,$3);

    if ($array eq 'var') {
     $var{$r_1} = $r_2;
    } elsif ($array eq 'error') {
     $error{$r_1} = $r_2;
    } elsif ($array eq 'log_detail') {
     $log_detail{$r_1} = $r_2;
    } elsif ($array eq 'home') {
     if (defined($home{$r_1}) && $home{$r_1} ne '') {
      $home{$r_1} = $home{$r_1} . ',' . $r_2;
     } else {
      $home{$r_1} = $r_2;
     }
    } elsif ($array eq 'right') {
     $right{$r_1} = $r_2;
     $right[$r_2] = $r_1;
    }elsif ($array eq 'find') {
     $find{$r_1} = $r_2;
    } elsif ($array eq 'match') {
     $match{$r_1} = $r_2;
    }  
    $line[$x] = $';
   }
  }
  $x++;
 }
}


sub file_open () {
 my ($file_name,$file_mode) = @_;

 if (defined ($file_mode)) {
  if ($file_mode =~ />>/ or $file_mode =~ /append/) {
   $file_mode = '>>';
  } elsif ($file_mode =~ /</ or $file_mode =~ /read/) {
   $file_mode = '<';
  } elsif ($file_mode =~ />/ or $file_mode =~ /write/) {
   $file_mode = '>';
  }
 } else {
  $file_mode = '<';
 }

 if ($file_mode eq '<' && -e $file_name == 0) {
  error('file_exist',$file_name);
 }

 if (-d $file_name) {
  error('file_directory',$file_name);
 }

 unless (open (FILE, "$file_mode $file_name")) {
  chmod (0706, $file_name) or error('file_open_' . $file_mode . $file_name,$file_name);
  unless (open (FILE, "$file_mode $file_name")) {
   chmod (0766, $file_name) or error('file_open',$file_name);
   unless (open (FILE, "$file_mode $file_name")) {
    error('file_open',$file_name);
   }
  }
 }
 $file{name} = $file_name;
 $file{read} = 0;
}

sub file_read () {
 my $no_col = shift;
 @line = (); @col = (); %col = {}; 
 unless (defined $no_col) {
  $y = <FILE>; 	chomp($y); 	@col = split(/\|/, $y);	 
  $file{first} = $y;	$y = 0;
  while ($y < @col) {
   $col{ $col[$y] } = $y;
   $y++;
  }
 }
 $x = 0;
 while(<FILE>) {
  $line[$x] = $_; $x++;
 }
 if (defined $no_col) {
  $file{first} = $line[0];
 }
 $file{read} = 1;
}

sub file_close () {
 close (FILE) or error('file_close',$file{name});
}


###########################
### Formatkonvertierung ###
###########################


sub mask () {
 my $to_mask = shift;
 $to_mask =~ s/([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/\\$1/g;
 return $to_mask;
}

sub unmask () {
 my $to_unmask = shift;
 $to_unmask =~ s/\%20/ /g;
 while ($to_unmask =~ m/%(\w{2})/) {
  $to_unmask = $` . chr(hex($1)) . $';
 }  
 $to_unmask =~ s/%OA/<br>/g;   $to_unmask =~ s/\+/ /g;   $to_unmask =~ s/\n/<br>/g; 
 $to_unmask =~ s/\\([\\|\||\(|\)|\[|\]|\{|\}|\^|\$|\*|\?|\.])/$1/g;
 return $to_unmask;
}

sub add_var() {
 my $to_add = shift;
 while ($to_add =~ /\$(\w+)/) {
  my $r = $var{$1};
  $to_add =~ s/\$$1/$r/g;
 }
 return $to_add;
}


###############
### Ausgabe ###
###############


# Fehlermeldungen generieren

sub error () {
 my @args = @_;
 my $error_code = $args[0];
 my $error_text;
 if (defined($error{$error_code})) {
  $error_text = $error{$error_code};
 } else {
  $error_text = $error{unknown};
 }
 $error_text =~ s/\$error_code/$error_code/g;
 while ($error_text =~ /\$(\d+)/) {
  $cur = $1;
  if ($cur < @args) {
   $args[$cur] =~ s/\$(\d+)//g;
   $error_text =~ s/\$$cur/$args[$cur]/g;
  } else {
   $error_text =~ s/\$$cur/\?/g;
  }
 }
 html($error_text);
}

# (Html-)Text ausgeben

sub html () {
 my $html = shift;
 print "Content-type: text/html\n\n";
 print $html;
 exit;
}